/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: tSample1.c 300 2009-05-08 12:20:30Z ertl-takuya $
 */

/* 
 *  TvvO(1)̖{
 *
 *  ASPJ[l̊{IȓmF邽߂̃TvvOD
 *
 *  vO̊Tv:
 *
 *  [UC^tF[X󂯎C^XNi^XNID: MAIN_TASKCD
 *  x: MAIN_PRIORITYjƁC3̕s^XNi^XNID:
 *  TASK1`TASK3CDx: MID_PRIORITYjō\D܂CN
 *  2b̎nhinhID: CYCHDR1jpD
 *
 *  s^XŃCtask_loop󃋁[vsxɁC^XN
 *  sł邱Ƃ킷bZ[W\D
 *
 *  nh́CO̗DxiHIGH_PRIORITYCMID_PRIORITYC
 *  LOW_PRIORITYj̃fBL[]DvŐŃC
 *  nh͒~ԂɂȂĂD
 *
 *  C^XŃCVAI/O|[g͂̕si͂
 *  ҂ĂԂ́Cs^XNsĂjC͂ꂽ
 *  ɑΉsD͂ꂽƏ̊֌W͎̒ʂD
 *  Control-C܂'Q'͂ƁCvOID
 *
 *  '1' : Ώۃ^XNTASK1ɐ؂芷iݒjD
 *  '2' : Ώۃ^XNTASK2ɐ؂芷D
 *  '3' : Ώۃ^XNTASK3ɐ؂芷D
 *  'a' : Ώۃ^XNcTask_activateɂND
 *  'A' : Ώۃ^XNɑ΂NvcTask_cancelActivateɂLZD
 *  'e' : Ώۃ^XNexitTaskĂяoCID
 *  't' : Ώۃ^XNcTask_terminateɂ苭ID
 *  '>' : Ώۃ^XN̗DxHIGH_PRIORITYɂD
 *  '=' : Ώۃ^XN̗DxMID_PRIORITYɂD
 *  '<' : Ώۃ^XN̗DxLOW_PRIORITYɂD
 *  'G' : Ώۃ^XN̗DxcTask_getPriorityœǂݏoD
 *  's' : Ώۃ^XNsleepĂяoCN҂ɂD
 *  'S' : Ώۃ^XNsleepTimeout10b)ĂяoCN҂ɂD
 *  'w' : Ώۃ^XNcTask_wakeupɂND
 *  'W' : Ώۃ^XNɑ΂NvcTask_cancelWakeupɂLZD
 *  'l' : Ώۃ^XNcTask_releaseWaitɂ苭Iɑ҂ɂD
 *  'u' : Ώۃ^XNcTask_suspendɂ苭҂ԂɂD
 *  'm' : Ώۃ^XN̋҂ԂcTask_resumeɂD
 *  'd' : Ώۃ^XNdelay(10b)ĂяoCԌoߑ҂ɂD
 *  'x' : Ώۃ^XNɗOp^[0x0001̗OvD
 *  'X' : Ώۃ^XNɗOp^[0x0002̗OvD
 *  'y' : Ώۃ^XNdisableTaskExceptionĂяoC^XNO֎~D
 *  'Y' : Ώۃ^XNenableTaskExceptionĂяoC^XNOD
 *  'r' : 3̗DxiHIGH_PRIORITYCMID_PRIORITYCLOW_PRIORITYj̃
 *        fBL[]D
 *  'c' : nh𓮍JnD
 *  'C' : nh𓮍~D
 *  'b' : A[nh5bɋN悤JnD
 *  'B' : A[nh𓮍~D
 *  'z' : Ώۃ^XNCPUO𔭐i^XNIjD
 *  'Z' : Ώۃ^XNCPUbNԂCPUO𔭐ivO
 *        IjD
 *  'V' : getMicroTimeŐ\]pVXe2ǂށD
 *  'v' : sVXeR[\iftHgjD
 *  'q' : sVXeR[\ȂD
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delay_time );
 *   ER             rotateReadyQueue( PRI priority );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_task_id );
 *   ER             getTime( SYSTIM* p_system_time );
 *   ER             getMicroTime( SYSUTM* p_system_micro_time );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interrupt_priority );
 *   ER             getInterruptPriorityMask( PRI* p_interrupt_priority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * require port : signature: siKernel context: non-task
 *   ER             ciKernel_rotateReadyQueue( PRI priority );
 *   ER             ciKernel_getTaskId( ID* p_task_id );
 *   ER             ciKernel_getMicroTime( SYSUTM* p_system_micro_time );
 *   ER             ciKernel_lockCpu( );
 *   ER             ciKernel_unlockCpu( );
 *   ER             ciKernel_exitKernel( );
 *   bool_t         ciKernel_senseContext( );
 *   bool_t         ciKernel_senseLock( );
 *   bool_t         ciKernel_senseDispatch( );
 *   bool_t         ciKernel_senseDispatchPendingState( );
 *   bool_t         ciKernel_senseKernel( );
 *   bool_t         ciKernel_senseDispatchPendingStateCPU( const void* p_exception_infomation );
 *   bool_t         ciKernel_senseTaskExceptionPendingStateCPU( const void* p_exception_infomation );
 * call port : cTask  signature: sTask context: task
 *   ER             cTask_activate( subscript );
 *   ER_UINT        cTask_cancelActivate( subscript );
 *   ER             cTask_terminate( subscript );
 *   ER             cTask_changePriority( subscript, PRI priority );
 *   ER             cTask_getPriority( subscript, PRI* p_priority );
 *   ER             cTask_refer( subscript, T_RTSK* pk_task_status );
 *   ER             cTask_wakeup( subscript );
 *   ER_UINT        cTask_cancelWakeup( subscript );
 *   ER             cTask_releaseWait( subscript );
 *   ER             cTask_suspend( subscript );
 *   ER             cTask_resume( subscript );
 *   ER             cTask_raiseException( subscript, TEXPTN pattern );
 * call port : cCyclic  signature: sCyclic context: task
 *   ER             cCyclic_start( );
 *   ER             cCyclic_stop( );
 *   ER             cCyclic_refer( T_RCYC* pk_cyclic_handler_status );
 * call port : cAlarm  signature: sAlarm context: task
 *   ER             cAlarm_start( RELTIM alarm_time );
 *   ER             cAlarm_stop( );
 *   ER             cAlarm_refer( T_RALM* pk_alarm_status );
 * call port : cSerialPort  signature: sSerialPort context: task
 *   ER             cSerialPort_open( );
 *   ER             cSerialPort_close( );
 *   ER_UINT        cSerialPort_read( char_t* buf, uint_t len );
 *   ER_UINT        cSerialPort_write( const char_t* buf, uint_t len );
 *   ER             cSerialPort_control( uint_t ioctl );
 *   ER             cSerialPort_refer( T_SERIAL_RPOR* pk_rpor );
 * call port : cSysLog  signature: sSysLog context: task
 *   ER             cSysLog_write( uint_t prio, const SYSLOG* p_syslog );
 *   ER_UINT        cSysLog_read( SYSLOG* p_syslog );
 *   ER             cSysLog_mask( uint_t logmask, uint_t lowmask );
 *   ER             cSysLog_refer( T_SYSLOG_RLOG* pk_rlog );
 *
 * #[</PREAMBLE>]# */ 

#include "tSample1_tecsgen.h"
#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "kernel_cfg.h"
#include "tSample1.h"

/*
 *  T[rXR[̃G[̃Oo
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))

/*
 *  ss^XNւ̃bZ[Ẅ
 */
char_t	message[3];

/*
 *  [v
 */
ulong_t	task_loop;		/* ^XNł̃[v */
ulong_t	tex_loop;		/* O[`ł̃[v */

/*
 *  ss^XN
 */
void eSampleTask_main(int_t subscript)
{
	volatile ulong_t	i;
	int_t		n = 0;
	int_t		tskno = subscript + 1; 
	const char	*graph[] = { "|", "  +", "    *" };
	char_t		c;

	SVC_PERROR(enableTaskException());
	while (1) {
		syslog(LOG_NOTICE, "task%d is running (%03d).   %s",
										tskno, ++n, graph[tskno-1]);
		for (i = 0; i < task_loop; i++);
		c = message[tskno-1];
		message[tskno-1] = 0;
		switch (c) {
		case 'e':
			syslog(LOG_INFO, "#%d#exitTask()", tskno);
			SVC_PERROR(exitTask());
			assert(0);
		case 's':
			syslog(LOG_INFO, "#%d#sleep()", tskno);
			SVC_PERROR(sleep());
			break;
		case 'S':
			syslog(LOG_INFO, "#%d#sleepTimeout(10000)", tskno);
			SVC_PERROR(sleepTimeout(10000));
			break;
		case 'd':
			syslog(LOG_INFO, "#%d#delay(10000)", tskno);
			SVC_PERROR(delay(10000));
			break;
		case 'y':
			syslog(LOG_INFO, "#%d#disableTaskException()", tskno);
			SVC_PERROR(disableTaskException());
			break;
		case 'Y':
			syslog(LOG_INFO, "#%d#enableTaskException()", tskno);
			SVC_PERROR(enableTaskException());
			break;
#ifdef CPUEXC1
		case 'z':
			syslog(LOG_NOTICE, "#%d#raise CPU exception", tskno);
			RAISE_CPU_EXCEPTION;
			break;
		case 'Z':
			SVC_PERROR(lockCpu());
			syslog(LOG_NOTICE, "#%d#raise CPU exception", tskno);
			RAISE_CPU_EXCEPTION;
			SVC_PERROR(unlockCpu());
			break;
#endif /* CPUEXC1 */
		default:
			break;
		}
	}
}

/*
 *  sĎs^XNp̃^XNO[`
 */
void
eSampleException_main(int_t subscript, TEXPTN pattern)
{
	volatile ulong_t	i;
	int_t	tskno = (int_t) subscript;

	syslog(LOG_NOTICE, "task%d receives exception 0x%04x.", tskno + 1, pattern);
	for (i = 0; i < tex_loop; i++);

	if ((pattern & 0x8000U) != 0U) {
		syslog(LOG_INFO, "#%d#ext_tsk()", tskno);
		SVC_PERROR(exitTask());
		assert(0);
	}
}

/*
 *  CPUOnh
 */
#ifdef CPUEXC1

void
cpuexc_handler(void *p_excinf)
{
	ID		tskid;

	syslog(LOG_NOTICE, "CPU exception handler (p_excinf = %08p).", p_excinf);
	if (ciKernel_senseContext() != true) {
		syslog(LOG_WARNING,
					"ciKernel_senseContext() is not true in CPU exception handler.");
	}
	if (ciKernel_senseDispatchPendingState() != true) {
		syslog(LOG_WARNING,
					"ciKernel_senseDispatchPendingState() is not true in CPU exception handler.");
	}
	syslog(LOG_INFO, "ciKernel_senseLock() = %d ciKernel_senseDispatch() = %d ciKernel_senseContext() = %d",
		   ciKernel_senseLock(), ciKernel_senseDispatch(), ciKernel_senseContext());
	syslog(LOG_INFO, "xsns_dpn = %d xsns_xpn = %d",
		   ciKernel_senseDispatchPendingStateCPU(p_excinf),
		   ciKernel_senseDispatchPendingStateCPU(p_excinf));

	if (xsns_xpn(p_excinf)) {
		syslog(LOG_NOTICE, "Sample program ends with exception.");
		SVC_PERROR(ciKernel_senseKernel());
		assert(0);
	}

	SVC_PERROR(ciKernel_getTaskId(&tskid));
	SVC_PERROR(iras_tex(tskid, 0x8000U));
	
}

#endif /* CPUEXC1 */

/*
 *  nh
 *
 *  HIGH_PRIORITYCMID_PRIORITYCLOW_PRIORITY ̊eDx̃fBL[
 *  ]D
 */
/* #[<ENTRY_FUNC>]# eiCyclicHandler_main
 * name:         eiCyclicHandler_main
 * global_name:  tSample1_eiCyclicHandler_main
 * oneway:       
 * #[/ENTRY_FUNC>]# */
void
eiCyclicHandler_main()
{
	SVC_PERROR(ciKernel_rotateReadyQueue(HIGH_PRIORITY));
	SVC_PERROR(ciKernel_rotateReadyQueue(MID_PRIORITY));
	SVC_PERROR(ciKernel_rotateReadyQueue(LOW_PRIORITY));
}

/*
 *  A[nh
 *
 *  HIGH_PRIORITYCMID_PRIORITYCLOW_PRIORITY ̊eDx̃fBL[
 *  ]D
 */
/* #[<ENTRY_FUNC>]# eiAlarmHandler_main
 * name:         eiAlarmHandler_main
 * global_name:  tSample1_eiAlarmHandler_main
 * oneway:       
 * #[/ENTRY_FUNC>]# */
void
eiAlarmHandler_main()
{
	SVC_PERROR(ciKernel_rotateReadyQueue(HIGH_PRIORITY));
	SVC_PERROR(ciKernel_rotateReadyQueue(MID_PRIORITY));
	SVC_PERROR(ciKernel_rotateReadyQueue(LOW_PRIORITY));
}
/*
 *  C^XN
 */
/* ̐ݒ *//* #[<ENTRY_FUNC>]# eMainTask_main
 * name:         eMainTask_main
 * global_name:  tSample1_eMainTask_main
 * oneway:       
 * #[/ENTRY_FUNC>]# */
void
eMainTask_main()
{
	char_t	c;
	volatile ulong_t	i;
	int_t	tskno = 1;
	ER_UINT	ercd;	
	PRI		tskpri;
	SYSTIM	stime1, stime2;
#ifdef TOPPERS_SUPPORT_GET_UTM
	SYSUTM	utime1, utime2;
#endif /* TOPPERS_SUPPORT_GET_UTM */

	SVC_PERROR(cSysLog_mask(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts.");
	/*
	 *  VA|[g̏
	 *
	 *  VXeO^XNƓVA|[ggꍇȂǁCVA
	 *  |[gI[vς݂̏ꍇɂ͂E_OBJG[ɂȂ邪Cx
	 *  ȂD
	 */
	ercd = cSerialPort_open();
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `cSerialPort_open'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(cSerialPort_control(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV));

	/*
 	 *  [v񐔂̐ݒ
	 *
	 *  TASK_LOOP}N`ĂꍇC肹ɁCTASK_LOOPɒ
	 *  `ꂽlC^XNł̃[v񐔂ƂD
	 *
	 *  MEASURE_TWICE}N`ĂꍇC1ڂ̑茋ʂ̂
	 *  āC2ڂ̑茋ʂgD1ڂ̑͒߂̎Ԃo邽߁D
	 */
#ifdef TASK_LOOP
	task_loop = TASK_LOOP;
#else /* TASK_LOOP */

#ifdef MEASURE_TWICE
	task_loop = LOOP_REF;
	SVC_PERROR(getTime(&stime1));
	for (i = 0; i < task_loop; i++);
	SVC_PERROR(getTime(&stime2));
#endif /* MEASURE_TWICE */

	task_loop = LOOP_REF;
	SVC_PERROR(getTime(&stime1));
	for (i = 0; i < task_loop; i++);
	SVC_PERROR(getTime(&stime2));
	task_loop = LOOP_REF * 400UL / (stime2 - stime1);

#endif /* TASK_LOOP */
	tex_loop = task_loop / 5;

	/*
 	 *  ^XN̋N
	 */

	SVC_PERROR(cTask_activate( 1 ));
	SVC_PERROR(cTask_activate( 2 ));
	SVC_PERROR(cTask_activate( 3 ));

	/*
 	 *  C[v
	 */
	do {
		SVC_PERROR(cSerialPort_read(&c, 1));
		switch (c) {
		case 'e':
		case 's':
		case 'S':
		case 'd':
		case 'y':
		case 'Y':
		case 'z':
		case 'Z':
			message[tskno-1] = c;
			break;
		case '1':
			tskno = 1;
			break;
		case '2':
			tskno = 2;
			break;
		case '3':
			tskno = 3;
			break;
		case 'a':
			syslog(LOG_INFO, "#cTask_activate(%d)", tskno);
			SVC_PERROR(cTask_activate(tskno));
			break;
		case 'A':
			syslog(LOG_INFO, "#cTask_cancelActivate(%d)", tskno);
			SVC_PERROR(cTask_cancelActivate(tskno));

			if (ercd >= 0) {
				syslog(LOG_NOTICE, "cTask_cancelActivate(%d) returns %d", tskno, ercd);
			}
			break;
		case 't':
			syslog(LOG_INFO, "#cTask_terminate(%d)", tskno);
			SVC_PERROR(cTask_terminate(tskno));
			break;
		case '>':
			syslog(LOG_INFO, "#cTask_changePriority(%d, HIGH_PRIORITY)", tskno);
			SVC_PERROR(cTask_changePriority(tskno, HIGH_PRIORITY));
			break;
		case '=':
			syslog(LOG_INFO, "#cTask_changePriority(%d, MID_PRIORITY)", tskno);
			SVC_PERROR(cTask_changePriority(tskno, MID_PRIORITY));
			break;
		case '<':
			syslog(LOG_INFO, "#(cTask_changePriority(%d, LOW_PRIORITY)", tskno);
			SVC_PERROR(cTask_changePriority(tskno, LOW_PRIORITY));
			break;
		case 'G':
			syslog(LOG_INFO, "#cTask_getPriority(%d, &tskpri)", tskno);
			SVC_PERROR(ercd = cTask_getPriority(tskno, &tskpri));
			if (ercd >= 0) {
				syslog(LOG_NOTICE, "priority of task %d is %d", tskno, tskpri);
			}
			break;
		case 'w':
			syslog(LOG_INFO, "#cTask_wakeup(%d)", tskno);
			SVC_PERROR(cTask_wakeup(tskno));
			break;
		case 'W':
			syslog(LOG_INFO, "#cTask_cancelWakeup(%d)", tskno);
			SVC_PERROR(ercd = cTask_cancelWakeup(tskno));
			if (ercd >= 0) {
				syslog(LOG_NOTICE, "cTask_cancelWakeup(%d) returns %d", tskno, ercd);
			}
			break;
		case 'l':
			syslog(LOG_INFO, "#cTask_releaseWait(%d)", tskno);
			SVC_PERROR(cTask_releaseWait(tskno));
			break;
		case 'u':
			syslog(LOG_INFO, "#cTask_suspend(%d)", tskno);
			SVC_PERROR(cTask_suspend(tskno));
			break;
		case 'm':
			syslog(LOG_INFO, "#cTask_resume(%d)", tskno);
			SVC_PERROR(cTask_resume(tskno));
			break;
		case 'x':
			syslog(LOG_INFO, "#cTask_raiseException(%d, 0x0001U)", tskno);
			SVC_PERROR(cTask_raiseException(tskno, 0x0001U));
			break;
		case 'X':
			syslog(LOG_INFO, "#cTask_raiseException(%d, 0x0002U)", tskno);
			SVC_PERROR(cTask_raiseException(tskno, 0x0002U));
			break;
		case 'r':
			syslog(LOG_INFO, "#rotateReadyQueue(three priorities)");
			SVC_PERROR(rotateReadyQueue(HIGH_PRIORITY));
			SVC_PERROR(rotateReadyQueue(MID_PRIORITY));
			SVC_PERROR(rotateReadyQueue(LOW_PRIORITY));
			break;
		case 'c':
			syslog(LOG_INFO, "#cCyclic_start(1)");
			SVC_PERROR(cCyclic_start());
			break;
		case 'C':
			syslog(LOG_INFO, "#cCyclic_stop(1)");
			SVC_PERROR(cCyclic_stop());
			break;
		case 'b':
			syslog(LOG_INFO, "#cAlarm_start(1, 5000)");
			SVC_PERROR(cAlarm_start(5000));
			break;
		case 'B':
			syslog(LOG_INFO, "#cAlarm_stop()(1)");
			SVC_PERROR(cAlarm_stop());
			break;
		case 'V':
#ifdef TOPPERS_SUPPORT_GET_UTM
			SVC_PERROR(getMicroTime(&utime1));
			SVC_PERROR(getMicroTime(&utime2));
			syslog(LOG_NOTICE, "utime1 = %ld, utime2 = %ld",
										(ulong_t) utime1, (ulong_t) utime2);
#else /* TOPPERS_SUPPORT_GET_UTM */
			syslog(LOG_NOTICE, "getMicroTime is not supported.");
#endif /* TOPPERS_SUPPORT_GET_UTM */
			break;
		case 'v':
			SVC_PERROR(cSysLog_mask(LOG_UPTO(LOG_INFO),
										LOG_UPTO(LOG_EMERG)));
			break;
		case 'q':
			SVC_PERROR(cSysLog_mask(LOG_UPTO(LOG_NOTICE),
										LOG_UPTO(LOG_EMERG)));
			break;
#ifdef BIT_KERNEL
		case ' ':
			SVC_PERROR(lockCpu());
			{
				extern ER	bit_kernel(void);

				SVC_PERROR(ercd = bit_kernel());
				if (ercd >= 0) {
					syslog(LOG_NOTICE, "bit_kernel passed.");
				}
			}
			SVC_PERROR(unlockCpu());
			break;
#endif /* BIT_KERNEL */
		default:
			break;
		}
	} while (c != '\003' && c != 'Q');

	syslog(LOG_NOTICE, "Sample program ends.");
	SVC_PERROR(ciKernel_exitKernel());
	assert(0);
}
