#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2009 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: $
#++

module GenTransparentMarshaler
  #===  ؿΥɤƬӽϡ
  #ct_name:: Symbol    (through ץ饰줿) 륿̾ Symbol ȤƤʤ餷
  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

    # unmarshaler 饹?
    if ct_name == "#{@ct_name}_unmarshaler".to_sym then
      gen_ep_func_body_unmarshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
    else
      gen_ep_func_body_marshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
    end
  end

  #===  marshal ɤ
  def gen_ep_func_body_marshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

    b_void = false
    b_ret_er = false

    # ؿͤθη(typedef Ƥ)
    type = func_type.get_type.get_original_type

    # ͵Ѥѿϡvoid δؿǤϽϤʤ
    if ! type.kind_of?( VoidType ) then
      file.print( "    #{func_type.get_type.get_type_str}  retval_;\n" )
      if func_type.get_type.kind_of?( DefinedType ) && ( func_type.get_type.get_type_str == "ER" || func_type.get_type.get_type_str == "ER_INT" ) then
        b_ret_er = true
      end
    else
      b_void = true
    end

    file.print( "    ER      ercd_;\n" )
    file.print( "    FLGPTN  flgptn;\n" )

    # Ƥ signature Ф
    port = @celltype.find( @next_cell_port_name )
    signature = port.get_signature

    # ؿ ID ͡
    func_id = signature.get_id_from_func_name( func_name )
    file.print( "    int32_t  func_id_ = #{func_id};    /* id of #{func_name}: #{func_id} */\n" )

    # 󥰥ȥǤʤ
    if ! b_singleton then

      # singleton Ǥʤ p_cellcb ɤ
      file.print <<EOT
    #{ct_name}_CB *p_cellcb;

    if( VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
EOT

      # 顼֤
      if b_ret_er then
        file.print <<EOT
    }else{
         return ERCD( E_RPC, E_ID );
    }
EOT
      else
        file.print <<EOT
    }else{
        /* 顼ɤ򤳤˵ */
    }
EOT
      end
    end

    # channel lock 
    file.print <<EOT
    /* Channel Lock */
    if( is_cLockChannel_joined() )
      cLockChannel_wait();

EOT

    # SOP 
    file.print "    /* SOP */\n"
    file.print "    if( ( ercd_ = cTDR_sop( 1 ) ) != E_OK )\n"
    file.print "      goto error_reset;\n"

    # func_id 
    file.print "    /* ؿ id  */\n"
    file.print "    if( ( ercd_ = cTDR_put_int32( func_id_ ) ) != E_OK )\n"
    file.print "        goto error_reset;\n"

    # p "celltype_name, sig_name, func_name, func_global_name"
    # p "#{ct_name}, #{sig_name}, #{func_name}, #{func_global_name}"

    b_get = false    # marshal ʤ put
    b_marshal = true  # marshal

    # in Ϥ
    file.print "    /* ϰ */\n"
    print_params( params, file, 1, b_marshal, b_get, true, func_type.is_oneway? )
    print_params( params, file, 1, b_marshal, b_get, false, func_type.is_oneway? )
    if ! b_void && ! func_type.is_oneway? then
      ret_ptr_type = PtrType.new( func_type.get_type )
      print_param( "retval_", ret_ptr_type, file, 1, :RETURN, "&", nil, b_get )
    end

    file.print "    /* EOPСʥѥåȤݤ */\n"
    if ! func_type.is_oneway? then
      oneway = "1"
    else
      oneway = "2"
    end
    file.print "    if( (ercd_=cTDR_eop(#{oneway})) != E_OK )\n"
    file.print "        goto error_reset;\n\n"

    if ! func_type.is_oneway? then
      file.print <<EOT
    if( (ercd_=cEventflag_wait( 0x01, TWF_ANDW, &flgptn )) != E_OK ){
      ercd_ = ERCD(E_RPC,ercd_);
      goto error_reset;
    }
    if( (ercd_=cEventflag_clear( 0x00 ) ) != E_OK ){
      ercd_ = ERCD(E_RPC,ercd_);
      goto error_reset;
    }
EOT
    end # ! func_type.is_oneway?

    file.print <<EOT
    /* Channel Lock */
    if( is_cLockChannel_joined() )
      cLockChannel_signal();
EOT

    if( b_void == false )then
      # ƤӸͤ꥿
      file.print( "    return retval_;\n" )
    else
      file.print( "    return;\n" )
    end

    file.print <<EOT

error_reset:
    if( ercd_ != ERCD( E_RPC, E_RESET ) )
        (void)cTDR_reset();
EOT

    # channel lock 
    file.print <<EOT
    /* Channel Lock */
    if( is_cLockChannel_joined() )
      cLockChannel_signal();

EOT

    if( b_ret_er != false )then
      # ƤӸͤ꥿
      file.print( "    return ercd_;\n" )
    else
      file.print( "    return;\n" )
    end

  end

  #===  unmarshal ɤ
  def gen_ep_func_body_unmarshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

#    b_ret_er = true
    b_ret_er = false

    # func_id 륳ɤ
    file.print <<EOT

    int32_t   func_id_;
    ER        ercd_;

    #{ct_name}_CB *p_cellcb;

    if( VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
EOT

    if b_ret_er then
        file.print <<EOT
    }else{
        return ERCD( E_RPC, E_ID );
    }
EOT
    else
        file.print <<EOT
    }else{
        /* 顼ɤ򤳤˵ */
    }
EOT
    end

    file.print <<EOT

    /* SOPΥå */
    if( (ercd_=cTDR_is_sop( 1 )) != E_OK )
        goto error_reset;
    /* func_id μ */
    if( (ercd_=cTDR_get_int32( &func_id_ )) != E_OK )
        goto error_reset;

    syslog(LOG_INFO, "unmarshaler task: func_id: %d", func_id_ );
    switch( func_id_ ){
EOT

    # Ƥ signature Ф
    port = @celltype.find( @next_cell_port_name )
    signature = port.get_signature

    # through  signature ˴ޤޤ ٤ƤδؿˤĤ
    signature.get_function_head_array.each { |f|
      f_name = f.get_name
      f_type = f.get_declarator.get_type
      id = signature.get_id_from_func_name( f_name )

      # ؿ֤ͤĤ?
      if f_type.get_type.kind_of?( VoidType ) then
        b_void = true
      else
        b_void = false
      end

      # ѥåȤνå̤ΥǡĤäƤʤå
      file.print "    case #{id}:       /*** #{f_name} ***/ \n"
      file.print "    {\n"

# p "cServerCall_#{f_name}"

      # ѿ
      param_list = f.get_declarator.get_type.get_paramlist.get_items
           # FuncHead->  Decl->    FuncType->ParamList
      param_list.each{ |par|
        name = par.get_name
        type = par.get_type
        type_str = type.get_type_str.gsub( /\bconst\b */, "" ) # "const" 򳰤

        file.printf( "        %-12s %s%s;\n", type_str, name, type.get_type_str_post )
      }

      # ͤѿ
      if ! b_void then
        if f.is_oneway? then
          retval_ptr = ""   # oneway ξ硢뤬ΤƤ
        else
          retval_ptr = "*"
        end
        file.printf( "        %-12s #{retval_ptr}retval_%s;\n", f_type.get_type.get_type_str, f_type.get_type.get_type_str_post )
      end

      # in Ϥ
      file.print "\n        /* ϰ */\n"
      b_get = true    # unmarshal Ǥ get
      b_marshal  = false
      print_params( param_list, file, 2, b_marshal, b_get, true, f.is_oneway? )
      print_params( param_list, file, 2, b_marshal, b_get, false, f.is_oneway? )
      if ! b_void && ! f.is_oneway? then
        ret_ptr_type = PtrType.new( func_type.get_type )
        print_param( "retval_", ret_ptr_type, file, 2, :RETURN, nil, nil, b_get )
      end

      # ѥåȤμλ
      # mikan ϡоݴؿƽФ˼»ܤƽФѥåȤλѽŪȤ
      file.print "        /* ѥåȽå */\n"
      if ! f.is_oneway? then
        oneway = "1"
      else
        oneway = "2"
      end
      file.print "        if( (ercd_=cTDR_is_eop(#{oneway})) != E_OK )\n"
      file.print "            goto error_reset;\n\n"

      # оݴؿƽФ
      file.print "        /* оݴؿθƽФ */\n"
      if b_void then
        file.print( "        cServerCall_#{f_name}(" )
      else
        file.print( "        #{retval_ptr}retval_ = cServerCall_#{f_name}(" )
      end

      delim = " "
      param_list.each{ |par|
        file.print delim
        delim = ", "
        file.print "#{par.get_name}"
      }
      file.print( " );\n" )

      # ͡ϰμ襳ɤ

      # oneway ξϡ̵ͤԤʤƱʸƽФ
      if ! f.is_oneway? then
        file.print <<EOT
        /* ؿνλ */
        if( ( ercd_ = cEventflag_set( 0x01 ) ) != E_OK ){
          ercd_ = ERCD( E_RPC, ercd_ );
          goto error_reset;
        }
EOT
      end  # ! f.is_oneway?

      file.print "    }\n"
      file.print "    break;\n"

    } # 

    if @signature.need_PPAllocator? then
      ppallocator_dealloc_str = "    /* PPAllocator Τ٤Ƥ */\n    cPPAllocator_dealloc_all();"
    else
      ppallocator_dealloc_str = ""
    end


    file.print <<EOT
    default:
        syslog(LOG_INFO, "unmarshaler task: ERROR: unknown func_id: %d", func_id_ );
    };
#{ppallocator_dealloc_str}
    return;

error_reset:
    if( ercd_ != ERCD( E_RPC, E_RESET ) )
        (void)cTDR_reset();
#{ppallocator_dealloc_str}
EOT

  end

  # IN b_marshal, b_get
  #  b_marshal = true  && b_get == false   :  ޡϰ
  #  b_marshal = true  && b_get == true    :  ޡǽϰ
  #  b_marshal = false && b_get == true    :  ޡϰ
  #  b_marshal = false && b_get == get     :  ޡǽϰ
  def print_params( params, file, nest, b_marshal, b_get, b_referenced, b_oneway = false )
    params.each{ |param|
# p "#{param.get_name}:  b_marshal: #{b_marshal} b_get: #{b_get}"
      if ! ( b_referenced == param.is_referenced? )
        next
      end

      dir = param.get_direction
      if b_oneway && dir == :IN && param.get_type.get_original_type.kind_of?( PtrType ) then
        # oneway, in, PtrType ξ祳ԡ
        print_param_copy( param.get_name, param.get_type, file, nest, b_marshal, nil, nil, b_get )
      else
        if( b_get == false && b_marshal == true || b_get == true && b_marshal == false  )then
          case dir
#          when :IN, :INOUT, :SEND
          when :IN, :INOUT, :OUT, :SEND, :RECEIVE
            print_param( param.get_name, param.get_type, file, nest, b_marshal, nil, nil, b_get )
          end
        else
#         case dir
#         when :OUT, :INOUT, :RECEIVE
#         when :RECEIVE
#           print_param( param.get_name, param.get_type, file, nest, b_marshal, nil, nil, b_get )
#         end
        end
      end
    }
  end

  def print_param( name, type, file, nest, b_marshal, outer, outer2, b_get )
    indent = "    " * ( nest + 1 )

    case type
    when DefinedType
      print_param( name, type.get_type, file, nest, b_marshal, outer, outer2, b_get )
    when BoolType, IntType, FloatType, PtrType
      case type
      when BoolType
        type_str = "int8"
        cast_str = "int8_t"
      when IntType
        bit_size = type.get_bit_size
        case bit_size
        when -1
          type_str = "char"
          cast_str = "char_t"
        when -2
          type_str = "short"
          cast_str = "short_t"
        when -3
          type_str = "int"
          cast_str = "int_t"
        when -4
          type_str = "long"
          cast_str = "long_t"
        when -5
          type_str = "intptr"
          cast_str = "intptr_t"
        when 8, 16, 32, 64, 128
          type_str = "int#{bit_size}"
          cast_str = "int#{bit_size}_t"
        else
          raise "unknown bit_size '#{bit_size}' for int type "
        end

      when FloatType
        bit_size = type.get_bit_size
        if bit_size == 32 then
          type_str = "float32"
          cast_str = "float32_t"
        else
          type_str = "double64"
          cast_str = "double64_t"
        end

      when PtrType
        type_str = "intptr"
        cast_str = "intptr_t"
      end

      if type.get_type_str == cast_str then
        cast_str = ""
      else
        cast_str = "(" + cast_str + ")"
      end

      if( b_get )then
        cast_str.gsub!( /\)$/, "*)" )
        file.print "    " * nest
        file.print "if( ( ercd_ = cTDR_get_#{type_str}( #{cast_str}&(#{outer}#{name}#{outer2}) ) ) != E_OK )\n"
        file.print "    " * nest
        file.print "    goto error_reset;\n"
      else
        file.print "    " * nest
        file.print "if( ( ercd_ = cTDR_put_#{type_str}( #{cast_str}#{outer}#{name}#{outer2} ) ) != E_OK )\n"
        file.print "    " * nest
        file.print "    goto error_reset;\n"
      end

    when StructType
      members_decl =type.get_members_decl
      members_decl.get_items.each { |m|
        print_param( m.get_name, m.get_type, file, nest, b_marshal, "#{outer}#{name}#{outer2}.", nil, b_get )
      }

    when VoidType
    when EnumType  # mikan EnumType
    when FuncType  # mikan FuncType
    when ArrayType # mikan ArrayType
    end
  end

  def print_param_copy( name, type, file, nest, b_marshal, outer, outer2, b_get, b_ret = false )
    case type.get_type
    when PtrType
      # ťݥ
      # string ξ
      # ʳǥ顼ФΤϸ (RPCPlugin.rb ˰ܤ)
#      Generator.error( "array of string not supported for RPC" )  # mikan ʸ
    else
      if type.get_count then
        expr = type.get_count
      elsif type.get_size then
        expr = type.get_size
      else
        expr = type.get_string
        # ʳǥ顼ФΤϸ (RPCPlugin.rb ˰ܤ)
        # if expr == -1 then
        #  Generator.error( "length unspecified string is not permited for RPC" )  # mikan Ĺ̤ʸ
        # end
      end
      indent = "    " * nest

      if b_marshal == false then
        if expr then
          file.print <<EOT
#{indent}if(cPPAllocator_alloc(#{expr.to_s}*sizeof(#{type.get_type.get_type_str}), (void **)&#{name})!=E_OK)
#{indent}    goto error_reset;
EOT
        else
          file.print <<EOT
#{indent}if(cPPAllocator_alloc(sizeof(&#{name}), (void **)&#{name})!=E_OK)
#{indent}    goto error_reset;
EOT
        end
      end

      if expr then
        file.print <<EOT
#{indent}{
#{indent}    int    i_, length_ = #{expr.to_s};
#{indent}    for( i_ = 0; i_ < length_; i_++ ){
EOT
        outer2 = "[i_]#{outer2}"
        print_param( name, type.get_type, file, nest+2, b_marshal, outer, outer2, b_get )
        file.print <<EOT
#{indent}    }
#{indent}}
EOT
      else
        outer = "#{outer}(*"
        outer2 = ")#{outer2}"
        nest = nest - 2
        print_param( name, type.get_type, file, nest+2, b_marshal, outer, outer2, b_get )
      end
    end
  end

end
