/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tDriverTaskBody_template.c => src/tDriverTaskBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * gyroOffset       int32_t          ATTR_gyroOffset 
 * speed            int32_t          VAR_speed       
 * turn             int32_t          VAR_turn        
 *
 * Ăь֐ #_TCPF_#
 * call port : cLeftMotor  signature: sMotor context: task
 *   void           cLeftMotor_setPWM( int32_t pwm, bool_t brakeMode );
 *   void           cLeftMotor_setRevolution( int32_t revolution );
 *   void           cLeftMotor_getRevolution( int32_t* revolution );
 * call port : cRightMotor  signature: sMotor context: task
 *   void           cRightMotor_setPWM( int32_t pwm, bool_t brakeMode );
 *   void           cRightMotor_setRevolution( int32_t revolution );
 *   void           cRightMotor_getRevolution( int32_t* revolution );
 * call port : cGyroSensor  signature: sSensor context: task
 *   void           cGyroSensor_getValue( int32_t* value );
 * call port : cBattery  signature: sNXTBattery context: task
 *   uint32_t       cBattery_getBatteryVoltage( );
 * call port : cBalancer  signature: sBalancer context: task
 *   void           cBalancer_initialize( );
 *   void           cBalancer_control( int16_t forward, int16_t turn, int32_t gyro, int32_t gyroOffset, int32_t leftRevolution, int32_t rightRevolution, uint32_t battery, int8_t* pwm_l, int8_t* pwm_r );
 *
 * #[</PREAMBLE>]# */

#include "tDriverTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tDriverTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	int32_t gyro;          // WCZTl
	int32_t rev_l, rev_r;  // [^̉]
	int8_t  pwm_l, pwm_r;  // [^ɗ^PWMl

	/*
	 *  WCZTl̎擾
	 */
	cGyroSensor_getValue(&gyro);

	/*
	 *  [^̉]擾
	 */
	cLeftMotor_getRevolution(&rev_l);
	cRightMotor_getRevolution(&rev_r);
	
	/*
	 *  |̂߂PWMľvZ
	 */
	cBalancer_control((int16_t)VAR_speed,
					  (int16_t)VAR_turn,
					  gyro,
					  ATTR_gyroOffset,
					  rev_l,
					  rev_r,
					  cBattery_getBatteryVoltage(),
					  &pwm_l,
					  &pwm_r);

	/*
	 *  PWMl[^ɃZbg
	 */
	cLeftMotor_setPWM(pwm_l, 1);
	cRightMotor_setPWM(pwm_r, 1);
}

/* #[<ENTRY_PORT>]# eDrive
 * entry port: eDrive
 * signature:  sDrive
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eDrive_setTurn
 * name:         eDrive_setTurn
 * global_name:  tDriverTaskBody_eDrive_setTurn
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDrive_setTurn(int32_t turn)
{
	/*
	 *  turnlXV
	 */
	VAR_turn = turn;
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
