#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2009 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: componentobj.rb 92 2008-05-26 01:43:38Z okuma-top $
#++

# STAGE:
#  B    bnf.y.rb ƽФ
#  P    parse ʳǸƽФbnf.y.rb ľܸƽФ櫓ǤϤʤʸԤ
#  S    P 椫ƽФ뤬ʸ櫓ǤϤʤ̣å
#  G    ʤʳǡʸڤϴǤ롥Դʤ饨顼ǤƤ
#                                                   factory  "format" θΰ

# mikan ʲ ruby  mix in Ǽ¸Ǥ뤫⤷ʤ
# Nestable Ѿ硢饹ѿ Nestable ΤΤ̤ͭˤä
# class Nestable
#   @@nest_stack_index = -1
#   @@nest_stack = []
#   @@current_object = nil
# 
#   def self.push
#     @@nest_stack_index += 1
#     @@nest_stack[ @nest_stack_index ] = @@current_object
#     @@current_object = nil
#   end
# 
#   def pop
#     @@current_object = @@nest_stack[ @@nest_stack_index ]
#     @nest_stack_index -= 1
#     if @@nest_stack_index < -1 then
#       raise TooManyRestore
#     end
#   end
# end

#
class Signature
#  @name:: Token
#  @global_name:: name
#  @function_head_list:: NamedList : FuncHead Υ󥹥󥹤
#  @func_name_to_id::  {String}  :  ؿ̾źȤ id 򵭲롥id  signature νи (1Ϥޤ)
#  @context:: string : ƥ̾
#  @b_need_PPAllocator:: bool : oneway  in 󤬤
#  @b_deviate:: deviate : æpointer level mismatch Фʤ

  @@nest_stack_index = -1
  @@nest_stack = []
  @@current_object = nil

  def self.push
    @@nest_stack_index += 1
    @@nest_stack[ @@nest_stack_index ] = @@current_object
    @@current_object = nil
  end

  def self.pop
    @@current_object = @@nest_stack[ @@nest_stack_index ]
    @@nest_stack_index -= 1
    if @@nest_stack_index < -1 then
      raise "TooManyRestore"
    end
  end

  def self.get_current
    @@current_object
  end

  def initialize( name )
    @name = name
    Namespace.new_signature( self )
    if #{Namespace.get_global_name} == "" then
      @global_name = @name
    else
      @global_name = "#{Namespace.get_global_name}_#{@name}"
    end

    @func_name_to_id = {}
    @context = nil
    @b_deviate = false
    @b_need_PPAllocator = nil
    @@current_object = self
    set_specifier_list( Generator.get_statement_specifier )
  end

  def end_of_parse( function_head_list )
    @function_head_list = function_head_list

    # id դ
    id = 1
    function_head_list.get_items.each{ |f|
      @func_name_to_id[ f.get_name ] = id
      id += 1
    }

    @@current_object = nil
    return self
  end

  #=== Ҥ
  #spec_list::      [ [ :CONTEXT,  String ], ... ]
  #                     s[0]        s[1]
  def set_specifier_list( spec_list )
    return if spec_list == nil  # ʤв⤷ʤ

    spec_list.each { |s|
      case s[0]     # statement_specifier
      when :CONTEXT         # [context("non-task")] etc
        if @context then
          Generator.error( " context specifier duplicate" )
        end
        @context = s[1].gsub( /\A\"(.*)\"$/, "\\1" )
        case @context
        when "non-task", "task", "any"
        else
          Generator.warning( "'#{@context}': unknown context type. usually specifiy task, non-task or any" )
        end
      when :DEVIATE
        @b_deviate = true
      else
        Generator.error( "'#{s[0]}': unknown specifier for signature" )
      end
    }
  end

  def get_name
    @name
  end

  def get_global_name
    @global_name
  end

  def get_path
    # mikan namespace
    [ @name ]
  end

  def get_function_head_array
    if @function_head_list then
      return @function_head_list.get_items
    else
      return nil
    end
  end

  def get_function_head( func_name )
    return @function_head_list.get_item( func_name )
  end

  #=== ؿ̾ signature  id 
  def get_id_from_func_name func_name
    @func_name_to_id[ func_name ]
  end

  #=== context 
  # context ʸ֤ "task", "non-task", "any"
  # ̤ΥǥեȤȤ task ֤
  def get_context
    if @context then
      return @context
    else
      return "task"
    end
  end

  #=== signaure Τ٤ƤδؿΤ٤ƤΥѥ᡼򤿤ɤ
  #block:: ֥å˼
  # ֥å2Ĥΰ  Decl, ParamDecl     ( Decl: ؿإå )
  # Port 饹ˤ each_param ƱƯ
  def each_param # ֥å { |func_decl, param_decl| }
    fha = get_function_head_array                       # ƤӸޤϼΥ˥δؿ
    return if fha == nil                                # nil ʤʸˡ顼ͭͤꤵʤä

    pr = Proc.new   # Υ᥽åɤΥ֥å pr 
    fha.each{ |fh|  # fh: FuncHead                      # ؿγƴؿƬ
      fd = fh.get_declarator                            # fd: Decl  (ؿƬDeclarotor)
      if fd.is_function? then                           # fd ؿǤʤСǤ˥顼
        fd.get_type.get_paramlist.get_items.each{ |par| # ٤ƤΥѥ᡼ˤĤ
          pr.call( fd, par )
        }
      end
    }
  end

  #=== ʥ ˥㤫ƥȤ
  # alloc, dealloc ؿĤɤ줾졢ݥ󥿡ݥ󥿤ؤΥݥ󥿡ʤ
  def is_allocator?
    fha = get_function_head_array                       # ƤӸޤϼΥ˥δؿ
    if fha == nil then                                  # nil ʤʸˡ顼ͭͤꤵʤä
      return false
    end

    found_alloc = false; found_dealloc = false
    fha.each{ |fh|  # fh: FuncHead                      # ؿγƴؿƬ
      fd = fh.get_declarator                            # fd: Decl  (ؿƬDeclarotor)
      if fd.is_function? then                           # fd ؿǤʤСǤ˥顼
        func_name = fd.get_name.to_s 
        if func_name == "alloc" then
          found_alloc = true
          params = fd.get_type.get_paramlist.get_items
          if params then
            if ! params[0].instance_of?( ParamDecl ) || ! params[0].get_type.kind_of?( IntType ) then
              Generator.error( "#{@name}: 'alloc' 1st parameter not integer type" )
            elsif ! params[1].instance_of?( ParamDecl ) ||
                ! params[1].get_type.kind_of?( PtrType ) ||
                ! params[1].get_type.get_type.kind_of?( PtrType ) then
              Generator.error( "#{@name}: 'alloc' 2nd parameter not double pointer" )
            end
          else
            Generator.error( "#{@name}: 'alloc' has no parameter, unsuitable for allocator signature" )
          end
        elsif func_name == "dealloc" then
          found_dealloc = true
          params = fd.get_type.get_paramlist.get_items
          if params then
            if ! params[0].instance_of?( ParamDecl ) ||
                ! params[0].get_type.kind_of?( PtrType ) then
              Generator.error( "#{@name}: 'dealloc' 1st parameter not pointer type" )
#            elsif params[1] != nil then    # ϥåʤ
#              Generator.error( "#{@name}: 'dealloc' cannot has 2nd parameter" )
            end
          else
            Generator.error( "#{@name}: 'dealloc' has no parameter, unsuitable for allocator signature" )
          end
        end
        if found_alloc && found_dealloc then
          return true
        end
      end
    }
    if ! found_alloc then
      Generator.error( "#{@name}: 'alloc' function not found, unsuitable for allocator signature" )
    end
    if ! found_dealloc then
      Generator.error( "#{@name}: 'dealloc' function not found, unsuitable for allocator signature" )
    end
    return false
  end

  #=== æ
  #  deviate ꤵƤ true 
  def is_deviate?
    @b_deviate
  end

  #=== Push Pop Allocator ɬפ
  # Transparent RPC ξ oneway  in (size_is, count_is, string Τ줫ǽˤ
  def need_PPAllocator?( b_opaque = false )
    if @b_need_PPAllocator == nil then
      fha = get_function_head_array                       # ƤӸޤϼΥ˥δؿ
      fha.each{ |fh|
        fd = fh.get_declarator
        if fd.get_type.need_PPAllocator?( b_opaque ) then
          # p "#{fd.get_name} need_PPAllocator: true"
          @b_need_PPAllocator = true
          return true
        end
        # p "#{fd.get_name} need_PPAllocator: false"
      }
      @b_need_PPAllocator = false
      return false
    else
      return @b_need_PPAllocator
    end
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Signature: name: #{@name} context: #{@context} deviate : #{@b_deviate} PPAllocator: #{@b_PPAllocator}"
    (indent+1).times { print "  " }
    puts "function head list:"
    @function_head_list.show_tree( indent + 2 )
  end

end

class Celltype # < Nestable
# @name:: str
# @global_name:: str
# @name_list:: NamedList item: Decl (attribute, var), Port
# @port:: Port[]
# @attribute:: Decl[]
# @var:: Decl[]
# @require:: [[cp_name,Celltype|Cell,Port],...]
# @factory_list::   Factory[]
# @ct_factory_list::    Factory[] :    celltype factory
# @cell_list:: Cell[] : Τ (V1.0.0.2 ʹ)
# @singleton:: bool
# @b_singleton_defined:: bool : Ϥ singleton Ѥ
# @idx_is_id:: bool
# @active:: bool
# @b_reuse:: bool :  reuse ꤵ import 줿(template )
#
# @n_attribute_ro:: int >= 0    none specified
# @n_attribute_rw:: int >= 0    # of [rw] specified cells (obsolete)
# @n_attribute_omit : int >= 0  # of [omit] specified cells
# @n_var:: int >= 0
# @n_var_size_is:: int >= 0     # of [size_is] specified cells # mikan count_is
# @n_var_omit:: int >= 0        # of [omit] specified  cells # mikan var  omit ͭ
# @n_call_port:: int >= 0
# @n_call_port_array:: int >= 0
# @n_call_port_omitted_in_CB:: int >= 0   ŬǾάƤӸ
# @n_entry_port:: int >= 0
# @n_entry_port_array:: int >= 0
# @n_entry_port_inline:: int >= 0
# @n_cell_gen:: int >= 0  륻οƬǻФ롥̣ʳǤϻԲ
# @id_base:: Integer : cell  ID κǾ(ͤ @id_base + @n_cell)
#
# @b_cp_optimized:: bool : ƤӸŬ»
# @plugin:: PluginObject

  @@nest_stack_index = -1
  @@nest_stack = []
  @@current_object = nil

  def self.push
    @@nest_stack_index += 1
    @@nest_stack[ @@nest_stack_index ] = @@current_object
    @@current_object = nil
  end

  def self.pop
    @@current_object = @@nest_stack[ @@nest_stack_index ]
    @@nest_stack_index -= 1
    if @@nest_stack_index < -1 then
      raise "TooManyRestore"
    end
  end

  def initialize( name )
    @@current_object = self
    @name = name
    if "#{Namespace.get_global_name}" != "" then
      @global_name = "#{Namespace.get_global_name}_#{@name}"
    else
      @global_name = name
    end

    @name_list = NamedList.new( nil, %|symbol in celltype "#{name}"| )
    @port = []
    @attribute = []
    @var = []
    @require = []
    @factory_list = []
    @ct_factory_list = []
    @cell_list = []
    @singleton = false
    @b_singleton_defined = false
    @active = false

    @n_attribute_ro = 0
    @n_attribute_rw = 0
    @n_attribute_omit = 0
    @n_var = 0
    @n_var_omit = 0
    @n_var_size_is = 0
    @n_call_port = 0
    @n_call_port_array = 0
    @n_call_port_omitted_in_CB = 0
    @n_entry_port = 0
    @n_entry_port_array = 0
    @n_entry_port_inline = 0
    @n_cell_gen = 0

    @b_cp_optimized = false

    @plugin = Generator.get_plugin
      # plugin ξ PluginObject ֤
    #  Generator ƽФ줿 Generator ǥѡӰ̣åƤ

    if @plugin
      # plugin 륻륿פϺѤǤϤʤ
      @b_reuse = false
    else
      @b_reuse = Generator.is_reuse?
    end

    if $idx_is_id then
      @idx_is_id = true
    else
      @idx_is_id = false
    end

    Namespace.new_celltype( self )

  end

  def get_name
    @name
  end

  def end_of_parse
    # °ѿΥå
    check_attribute

    # ƤӸ
    generate_allocator_port

    # 졼ե
    @port.each { |p|
      p.set_allocator_instance
    }

    if @n_entry_port == 0 && @active == false && @factory_list.length == 0 &&
        ( @singleton && @ct_factory_list.length == 0 || ! @singleton )then
      Generator.warning( "#{@name}: non-active celltype has no entry port & factory" )
    end

    @@current_object = nil
  end

  def self.new_port( port )
    @@current_object.new_port( port )
  end

  def new_port( port )
    @port << port
    @name_list.add_item( port )
    if port.get_port_type == :CALL then
      @n_call_port += 1
      @n_call_port_array += 1 if port.get_array_size != nil
    else
      @n_entry_port += 1
      @n_entry_port_array += 1 if port.get_array_size != nil
      @n_entry_port_inline += 1 if port.is_inline?
    end
    port.set_celltype self
  end

  def get_port_list
    @port
  end

  def self.new_attribute( attribute )
    @@current_object.new_attribute( attribute )
  end

  #=== new_attribute for Celltype
  #attribute:: [Decl]
  def new_attribute( attribute )
    @attribute += attribute
    attribute.each { |a|
      @name_list.add_item( a )
      if( a.is_omit? )then
        @n_attribute_omit += 1
      elsif( a.is_rw? )then
        @n_attribute_rw += 1
      else
        @n_attribute_ro += 1
      end
      if a.get_initializer then
        # Ͽ˥åƤʤattr 򻲾ȤǤʤΤǡʻȤʤ
        a.get_type.check_init( a.get_identifier, a.get_initializer, :ATTRIBUTE )
      end
    }
  end

  #=== celltype  attribute/var Υå
  # STAGE:  S
  #
  # Υ᥽åɤ celltype ΥѡλǸƽФ롥
  def check_attribute
    # attribute  size_is ꤬å
    (@attribute+@var).each{ |a|
      if a.get_size_is then
        if ! a.get_type.kind_of?( PtrType ) then
          # size_is ݥ󥿷ʳ˻ꤵ줿
          Generator.error( "#{a.get_identifier}: size_is specified for non-pointer type" )
        else

          # Ȥѿ¸ߤ׻ǽʷå
          size = a.get_size_is.eval_const( @name_list )  # C_EXP βǽ
          init = a.get_initializer
          if init then
            if ! init.instance_of?( Array ) then
              # ҤǤϤʤ
              Generator.error( "#{a.get_identifier}: unsuitable initializer, need array initializer" )
            elsif size.kind_of?( Integer ) && size < init.length then
              # size_is ꤵ줿ĿҤǤ¿
              Generator.error( "#{a.get_identifier}: too many initializer, #{init.length} for #{size}" )
            end
          end
        end
      end
    }
  end

  def get_attribute_list
    @attribute
  end

  #=== ƤӸ
  #    send, receive ΥƽФθƤӸ
  def generate_allocator_port
    @port.each { |port|
      # ݡȤΤ٤ƤΥѥ᡼é
      port.each_param { |port, fd, par|
        case par.get_direction                        #  (in, out, inout, send, receive )
        when :SEND, :RECEIVE
          if par.get_allocator then
            cp_name = "#{port.get_name}_#{fd.get_name}_#{par.get_name}".to_sym     # ƤӸ̾
            #           ݡ̾          ؿ̾         ѥ᡼̾
            alloc_sig_path = [ par.get_allocator.get_name ]  # mikan Namespace ƤӸΥ˥
            array_size = port.get_array_size            # ƤӸޤϼΥ
            created_port = Port.new( cp_name, alloc_sig_path, :CALL, array_size ) # ƤӸ
            created_port.set_allocator_port( port, fd, par )
            Celltype.new_port( created_port )           # 륿פ˿ƤӸɲ
          # else
          #  already error "not found or not signature" in class ParamDecl
          end
        end
      }
    }
  end

  def get_name_list
    @name_list
  end

  def self.new_var( var )
    @@current_object.new_var( var )
  end

  #===
  #var:: [Decl]
  def new_var( var )
    @var += var
    var.each { |i|     # i: Decl
      if i.is_omit? then
        @n_var_omit += 1
      else
        @n_var += 1
      end
      @name_list.add_item( i )

      # size_is ꤵ줿? mikan  count_is
      if i.get_size_is then
        @n_var_size_is += 1
      end

      if i.get_initializer then
        i.get_type.check_init( i.get_identifier, i.get_initializer, :VAR, @name_list )
      end
    }
  end

  def get_var_list
    @var
  end

  def set_specifier( spec )
    spec.each { |s|
      case s
      when :SINGLETON
        @singleton = true
      when :IDX_IS_ID
        @idx_is_id = true
      when :ACTIVE
        @active = true
      end
    }
  end

  #
  def self.new_require( ct_or_cell_name, ep_name, cp_name = nil )
    @@current_object.new_require( ct_or_cell_name, ep_name, cp_name )
  end

  def new_require( ct_or_cell_name, ep_name, cp_name )
    obj = Namespace.find( ct_or_cell_name )
    if obj.instance_of? Celltype then
      # Celltype ̾ǻ
      ct = obj
    elsif obj.instance_of? Cell then
      # Cell ̾ǻ
      ct = obj.get_celltype
    elsif obj == nil then
      Generator.error( "#{ct_or_cell_name} not found" )
      return
    else
      Generator.error( "#{ct_or_cell_name} : neither celltype nor cell" )
      return
    end

    if( ! ct.is_singleton? ) then
      # 󥰥ȥǤϤʤ
      Generator.error( "#{obj.get_name} : not singleton cell" )
    end

    # õ
    obj2 = ct.find( ep_name )
    if( ( ! obj2.instance_of? Port ) || obj2.get_port_type != :ENTRY ) then
      Generator.error( "'#{ep_name}' : not entry port" )
      return
    elsif obj2.get_array_size then
      Generator.error( "'#{ep_name}' : required port cannot be array" )
      return
    end

    require_call_port_prefix = "_require_call_port"
    if cp_name == nil then
      # ؿ̾ʣå
      @require.each{ |req|
        unless req[0] =~ /^#{require_call_port_prefix}/ then
          next     # ̾ require ϴؿ̾ʣåʤ
        end
        port = req[2]
        if port.get_signature == obj2.get_signature then
          # Ʊ signature ʤ٤Ʊؿ̾ġ˸̤˽ФΤǤϤʤޤȤƥ顼Ȥ
          Generator.error( "#{obj2.get_name} : require cannot have same signature with '#{port.get_name}'" )
          next
        end
        port.get_signature.get_function_head_array.each{ |f|
          # mikan ϡnamedList θˤʤʤΡʸΨ
          obj2.get_signature.get_function_head_array.each{ |f2|
            if( f.get_name == f2.get_name ) then
              Generator.error( "#{obj.get_name}.#{obj2.get_name} : '#{f.get_name}' conflict function name in #{req[1].get_name}.#{req[2].get_name}" )
            end
          }
        }
      }
    end

    if cp_name == nil then
      b_has_name = false
      cp_name = "#{require_call_port_prefix}_#{ct.get_name}_#{obj2.get_name}"
    else
      b_has_name = true
    end
    # require ɲ
    @require << [ cp_name, obj, obj2 ]  # [ lhs:cp_name, rhs:Celltype, rhs:Port ]

    # require port ɲ (ƤӸȤɲä롣 require 򥻥åȤƤ)
    port = Port.new( cp_name, obj2.get_signature.get_path, :CALL )
    port.set_require( b_has_name )
    self.new_port port
  end

  def self.new_factory( factory )
    @@current_object.new_factory( factory )
  end

  def new_factory( factory )

    if factory.get_f_celltype then
      @ct_factory_list << factory
    else
      @factory_list << factory
    end

    factory.check_arg( self )

  end

  #=== celltype ˿ cell ɲ
  #cell:: Cell
  # 򥻥륿פɲá
  # ιʸκǸǤΥ᥽ɤƽФ롥
  # 󥰥ȥ󥻥뤬ʣʤå
  def new_cell( cell )
    @cell_list << cell
    # 󥰥ȥǡץȥǤʤ硢оݥ꡼ξ
    if @singleton  && cell.is_generate? then
      if @b_singleton_defined then
        Generator.error( "#{@name}: multiple cell for singleton celltype" )
      else
        @b_singleton_defined = true
      end
    end
  end

  #=== 륿פ INIB Ĥ
  # 륿פ INIB ĤɤȽꤹ
  # $rom == false ΤȤ:  INIB ʤ ʤ٤Ƥ CB ֤
  # $rom == true ΤȤINIB ֤ΤĤǤ¸ߤ INIB 
  #   INIB ֤Τ
  #     attribute (omit ΤΤϽͤǤ rw ΤΤϤʤ)
  #     size_is ȼ var
  #     ƤӸʤŬפȤʤΤϽ
  def has_INIB?
    return $rom && (@n_attribute_ro > 0 || @n_var_size_is > 0 || ( @n_call_port - @n_call_port_omitted_in_CB ) > 0)
#    return $rom && (@n_attribute_ro > 0 || ( @n_call_port - @n_call_port_omitted_in_CB ) > 0)
  end

  #=== 륿פ CB Ĥ
  # $rom == true ΤȤΤΤ֤롥ΰĤǤ¸ߤ CB 
  #   size_is ꤵƤʤ var
  #   rw ꤵ줿 attribute (ͤǤ¸ߤʤ)
  # $rom == false ΤȤΤΤ֤롥ΰĤǤ¸ߤ CB 
  #   attribute
  #   var
  #   ƤӸʤŬפȤʤΤϽ
  def has_CB?
    if $rom then
      return @n_attribute_rw > 0 || (@n_var-@n_var_size_is) > 0
      # return @n_attribute_rw > 0 || @n_var > 0
    else
      return @n_attribute_rw > 0 || @n_attribute_ro > 0 || @n_var > 0 || (@n_call_port-@n_call_port_omitted_in_CB) > 0
    end
  end

  def find( name )
    @name_list.get_item( name )
  end


  def get_global_name
    @global_name
  end

  def is_singleton?
    @singleton
  end

  def is_active?
    @active
  end

  #=== ƥ֤ǤϤʤ
  # Υ᥽åɤǤ active ¾ factory (singleton ˤƤ FACTORYޤ)ʤ inactive Ȥ
  def is_inactive?
    if @active == false && @factory_list.length == 0 &&
        ( @singleton && @ct_factory_list.length == 0 || ! @singleton )then
      return true
    end
    return false
  end

  def get_id_base
    @id_base
  end

  def get_plugin
    @plugin
  end

  def get_require
    @require
  end

  #=== ɬפ뤫Ƚ
  # θĿ 0 ʤ饻륿ץɤ
  def need_generate?
    @n_cell_gen > 0
  end

  #=== require ƤӸηԤ
  # 륿פ require ƤӸˤĤơԤ
  # 뤬ʤåԤ
  def set_require_join
    @require.each{ |req|
      if req[1].instance_of? Celltype
        cell = nil
        # require: celltype ǻ
        req[1].get_cell_list.each{ |c|
          # 륻õʣ singleton 뤫⤷ʤ
          if c.is_generate? then
            cell = c
            break
          end
        }
        if cell == nil then
          Generator.error( "not found genearting cell for require '#{req[2].get_name}' in celltype '#{req[1].get_name}'" )
        end
      else
        # require: cell ǻ
        cell = req[1]
        if cell.is_generate? != true then
          Generator.error( "required cell '#{cell.get_name}' not generating" )
        end
      end
      cp_name = req[0]
      port = req[2]
      if cell then
        @cell_list.each{ |c|
          c.set_require_join( cp_name, cell, port )
        }
      end
    }
  end

  def get_cell_list
    @cell_list
  end

  #=== inline ʤ
  # ̵硢٤Ƥμ inline ȤϤʤ
  def is_all_entry_inline?
    @n_entry_port == @n_entry_port_inline && @n_entry_port > 0
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Celltype: name: #{@name} global_name: #{@global_name}"  
    (indent+1).times { print "  " }
    puts "active: #{@active}, singleton: #{@singleton}, idx_is_id: #{@idx_is_id} plugin: #{@plugin.class} reuse: #{@b_reuse}"
    (indent+1).times { print "  " }
    puts "port:"
    @port.each { |i| i.show_tree( indent + 2 ) }
    (indent+1).times { print "  " }
    puts "attribute:"
    @attribute.each { |i| i.show_tree( indent + 2 ) }
    (indent+1).times { print "  " }
    puts "var:"
    @var.each { |i| i.show_tree( indent + 2 ) }
#    (indent+1).times { print "  " }
#    puts "require:"   mikan
#    @require.each { |i| i.show_tree( indent + 2 ) }
    (indent+1).times { print "  " }
    puts "factory:"
    @factory_list.each { |i| i.show_tree( indent + 2 ) }
    (indent+1).times { print "  " }
    puts "@n_attribute_ro #{@n_attribute_ro}"
    (indent+1).times { print "  " }
    puts "@n_attribute_rw #{@n_attribute_rw}"
# @n_attribute_omit : int >= 0  # of [omit] specified cells
# @n_var:: int >= 0
# @n_var_size_is:: int >= 0     # of [size_is] specified cells # mikan count_is
# @n_var_omit:: int >= 0        # of [omit] specified  cells # mikan var  omit ͭ
# @n_call_port:: int >= 0
# @n_call_port_array:: int >= 0
# @n_call_port_omitted_in_CB:: int >= 0   ŬǾάƤӸ
# @n_entry_port:: int >= 0
# @n_entry_port_array:: int >= 0
    (indent+1).times { print "  " }
    puts "@n_entry_port_inline #{@n_entry_port_inline}"
# @n_cell:: int >= 0  ƬǻФ롥̣ʳǤϻԲ
# @id_base:: Integer : cell  ID κǾ(ͤ @id_base + @n_cell)

  end
end

class Cell # < Nestable
# @name:: str : composite celltype ¦Υ󥹥󥹤ǤϳΥ
# @global_name:: str : C ǻȤ̾namespace ޤ
# @local_name:: str : cell celltype name { ... }  name
# @celltype:: Celltype | CompositeCelltype
# @join_list:: NamedList
# @f_def:: definition flag (false if only prototype )
# @b_duplicate:: bool:  definition duplicate
# @f_ref:: refercenced from others
# @prototypes:: Cell[] : prototype  : change_item Ρ¾黲ȤƤ뤫⤷ʤΡ
# @entry_array_max_subscript:: { @port=>Integer } : źκ͡ź̵б
#
# composite Τᥤ󥹥ѿ
# @in_composite:: bool : true if in composite celltype
# @compositecelltypejoin_list:: NamedList : item= CompositeCelltypeJoin ( if @in_composite )
# @f_clone:: bool : true if cloned (instantiate of composite consist cell)
# @my_clone:: Cell : Composite cell  in_composite = true ξΤͭľ clone 
# @cell_list:: Cell[local_name] : Composite cell  clone Υꥹ cell_list
#
# region ΤΥ󥹥ѿ
# @region:: Region (°region)
# @b_generate:: true if оݥ꡼°륻
#
# allocator ΤΥ󥹥ѿ
# @alloc_list::  [ [ ep_name, func_name, param_name, expr ], ... ]
#
# ID ΤΥ󥹥ѿoptimize.rb ˤ
# @id:: Integer : ľ  (ץȥξ -1 Τޤ)

  @@nest_stack_index = -1
  @@nest_stack = []
  @@current_object = nil

  def self.push
    @@nest_stack_index += 1
    @@nest_stack[ @@nest_stack_index ] = @@current_object
    @@current_object = nil
  end

  def self.pop
    @@current_object = @@nest_stack[ @@nest_stack_index ]
    @@nest_stack_index -= 1
    if @@nest_stack_index < -1 then
      raise "TooManyRestore"
    end
  end


  # composite  clone 줿Ρʻ¹ޤǴޤ
  # Join.change_rhs_port ˤ CompoisteCelltype  Join ηѹݤ˻
  @@cloned_cell_list = {}
  ### mikan BUG @@cloned_cell_list  composite γؤȤ˵ƤʤᡢƱ̾˸ȡޤưʤ
  # change_rhs_port μϡʲ꤯ɤȤ򤹤ɬפϤʤäդ˸륻̾ˤϡcomposite Υ̾ˤĤʤǤ褫ä


  def initialize( ct_path, in_composite = false )

    @region = Region.get_current
    @b_generate = @region.is_generate?

    # celltype ¸ߤå
    object = Namespace.find( ct_path )
    if object == nil then
      # mikan celltype ̾Դ "::ct1ct2" ˤʤ
      Generator.error( "'#{ct_path}' celltype not found" )
    elsif ! object.instance_of?( Celltype ) && ! object.instance_of?( CompositeCelltype ) then
      # mikan celltype ̾Դ
      Generator.error( "'#{ct_path}' not celltype" )
    else
      @celltype = object
    end

    @in_composite = in_composite
    if @in_composite then
      @compositecelltypejoin_list = NamedList.new( nil, "in cell '#{@name}'" )
    end

    @prototypes = []
    @@current_object = self
    @f_cloned = false
    @alloc_list = []
    @id = -1
    @b_duplicate = false
    @entry_array_max_subscript = {}
  end

  def self.set_name( name )
    @@current_object.set_name( name )
  end

  def set_name( name )

    @name = name
    @local_name = name
    if "#{Namespace.get_global_name}" != "" then
      @global_name = "#{Namespace.get_global_name}_#{name}"
    else
      @global_name = name
    end

    # λǤϥץȥפʬʤʻȤΤϿ
    # set_f_def ǺϿʤ
    # Celltype ؤϿϡend_of_parse ǹԤ
    if @in_composite then
      cell_prev = CompositeCelltype.find( name )
      if cell_prev == nil then
        CompositeCelltype.new_cell( self )
      end
    else
      cell_prev = Namespace.find( [ name ] )   # mikan namespace
      if cell_prev == nil then
        Namespace.new_cell( self )
      end
    end

    if cell_prev then
      if ! cell_prev.instance_of?( Cell ) then
        Generator.error( "#{name}: mismatch with previous one" )
        # celltype פƤ뤫 ?
      elsif get_celltype != cell_prev.get_celltype then
        Generator.error( "#{name}: celltype mismatch with previous one" )
      else
        # region פƤ뤫?
        if ! cell_prev.get_region.equal? get_region then
          Generator.error( "#{name} region '#{@region.get_name}' mismatch  with previous one '#{cell_prev.get_region.get_name}'" )
        end

        @@current_object = cell_prev
        # λǤϡޤץȥʬʤ
        # Ǥäơξ硢ʣ顼Ǥ
      end
    end

    @join_list = NamedList.new( nil, "in cell '#{@name}'" )

    # debug
    # print "Cell new_cell: #{@global_name} #{@in_composite} #{self}\n"
  end

  def self.new_join( join, b_regular = false )
    @@current_object.new_join( join, b_regular )
  end

  #===  å
  # STAGE:   P
  #
  #join::  Join : 
  #b_regular:: bool : ̾ξ (bnf.y.rb)ʤ true, ʳ(allocator, require) Ǥ false
  def new_join( join, b_regular = false )

    # νʣ顼ν
    if @f_def && @b_duplicate == false && b_regular == true then
      # ϼΤƤ
      # 顼 set_f_def 
      @b_duplicate = true
      @join_list = NamedList.new( nil, "in cell '#{@name}'" )
    end

    # composite οʸˡб
    # composite Υǡattribute Ǥ
    # cell  attr_ext = composite.attr; ʸ
    if @in_composite then
      if @celltype then
        if @celltype.find(join.get_name).instance_of?( Decl ) then
          rhs = join.get_rhs
          if rhs.instance_of? Expression then
            ele = rhs.get_elements
            if( ele[0]==:IDENTIFIER )then    #  attr = attr_ext ʱñˤ
              if( CompositeCelltype.has_attribute?(ele[1].to_s ) )then
                ident = ele[1].to_s   # դ attribute
              else
                # դ attribute ˤʤΤǤСΤϤ
                # ϲϤ (cell  join ˤ)
                ident = nil
              end
            else
              if join.get_rhs.eval_const2(nil) == nil then   # ǤϤʤ
                # դñΥܥǤʤ硢ϰʤ
                Generator.error( "rhs expression is not supported. Only attribute is permitted on current version." )
                return
              else
                # ϲϤ (cell  join ˤ)
                ident = nil
              end
            end

            if ident then
              # attr = attr; Τ褦ʻȤϥ顼 (a = composite.a Ȥɬפ)
              if @celltype.find( ident ) then
                Generator.error( "#{ident} : cannot refer to #{@celltype.get_name}'s attribute here. Use 'composite.#{ident}' to refer to composite celltype's" )
              end
            end
          elsif rhs.instance_of? Array then
            if rhs[0] == :COMPOSITE then   # դ composite.attr η
              ident = rhs[1].to_s
            else
              ident = nil    # դ { 10, -10 } η
            end
          else
            ident = nil      # դ C_EXP η
          end

          # ident Ĥäʱդñ ident
          if ident then
            # composite εʸˡιʸϤ볰 attr_ext = Cell.attr; ʸνϤ
            #                        export_name, internal_cell_name, internal_cell_elem_name
            decl = CompositeCelltype.new_join( ident, @name, join.get_name, :ATTRIBUTE )
            if ! decl.instance_of? Decl then
              return
            end
            ini = decl.get_initializer
            if ini == nil then
              return
            end
            # ʲεʸˡϤ
            # ʸˡǤ cell ˽ͤͿ뤳Ȥǡcomposite °νͤꤹ뤳ȤǤ
            # attribute ǻꤵ줿ͤ cell °Ȥƽ
            join.change_rhs( ini )
          else
            # ident ʤ
          end
        else
          # celltype °Ȥơ join ̾ʤ
          # ʲ join.set_definition ǥ顼Ȥʤ
        end
      else
        return    # celltype ʤǤ˥顼
      end
    elsif join.get_rhs.instance_of? Array then
      rhs = join.get_rhs
      if rhs[0] == :COMPOSITE then
        # composite ǤʤΤ attr = composite.attr Ȥ줿
        Generator.error( "composite : cannot specify out of composite celltype definition" )
        return
      end

    end

    # ʲ composite ʸˡѹ餢

    # ˺դƱ̾ν¸ߤ뤫
    j = @join_list.get_item( join.get_name )
    if j.instance_of? Join then    # mikan Ǥ j  Join or Nil ʳϡʤϤ

      # join å
      join.set_definition( @celltype.find(join.get_name) )

      # debug
      # print "add_array_member: #{@name} port: #{j.get_port_name} rhs: #{j.get_rhs}, #{join.get_port_name} #{join.get_rhs}\n"
      # ƤӸʤǤȲꤷơǤɲ
      j.add_array_member join

    else
      # join
      @join_list.add_item( join )
      if @celltype  # ° celltype ¸ߤƤ뤫
        join.set_definition( @celltype.find(join.get_name) )
      end
    end

    if ! @in_composite then
#     if join.get_cell
#       print "#{@name} #{@region.get_name} => #{join.get_cell.get_name} #{join.get_cell.get_region.get_path_string}\n"
#     end
#     p "region: generate? #{@region.is_generate?}"
    end

  end

  def self.external_join( internal_cell_elem_name, export_name, b_composite )
    @@current_object.external_join( internal_cell_elem_name, export_name, b_composite )
  end

  #=== cell ˵ҤƤӸγ
  # internal_cell_elem_name:: string : ƤӸ̾
  # export_name:: string: composite γ˸ƤӸ̾
  #  ƤӸ礹롥
  #  Υ᥽åɤϡcomposite  cell ǤƤФʤ
  def external_join( internal_cell_elem_name, export_name, b_composite )

    # cCall => composite.cCall; ǤϤʤ
    if( b_composite == false )then
      # cCall => cCall; Τ褦ʾ
      if @celltype.find( export_name ) then
        Generator.error( "#{export_name} : cannot refer to #{@celltype.get_name}'s here. Use 'composite.#{export_name}' to refer to composite celltype's" )
      end
    end
    # composite εʸˡˤ롢cell  cCall = Cell.cCall; ιʸϤ
    CompositeCelltype.new_join( export_name, @name,  internal_cell_elem_name, :CALL )
  end

  def self.end_of_parse f_def
    cell = @@current_object
    cell.end_of_parse f_def
    @@current_object = nil
    return cell
  end

  def end_of_parse f_def
    set_specifier_list( Generator.get_statement_specifier )
    set_f_def f_def
  end

  #===  ץȥ(false)(true)
  #    Υ᥽åɤϹʸκǸ˸ƽФ
  #f_def::     bool     false if prototype, true if definition
  def set_f_def f_def
    if @f_def then
      if f_def then
        Generator.error( "#{@name}: duplicate" )
        if @b_duplicate == false then
          #  @b_duplicate == false ʤΤ new_join ʤä
          @b_duplicate = true   # ǥåȤƤ⻲Ȥʤ
          @join_list = NamedList.new( nil, "in cell '#{@name}'" )
        end
      else
        # θ˥ץȥ줿
      end
    end

    if f_def then
      if ! @in_composite then
        if @celltype.instance_of? Celltype then
          @celltype.new_cell self
        end

        check_join
        @f_def = true   # check_join  true ˤʤ @join_list ꥢʥ졼

        if @celltype.instance_of?( CompositeCelltype ) then
          # Ÿ줿Υꥹ
          @@cloned_cell_list = {}

          # composite celltype  cell Ÿ
          @cell_list = @celltype.expand( @name, @global_name, @join_list )

          # ץȥפȤƤ硢Ҥ⻲ȤƤ뤳Ȥˤ
          if @f_ref then
            set_f_ref
          end

          # ƤӸαդΥ clone Τѹ
          self.change_rhs_port

          # ե @alloc_list ɲ
          @celltype.get_self_allocator_list.each{ |a|
            c = @cell_list[a[0].get_name.to_s]     # a[0]: ̾, clone 뤫õ
            next if c == nil
            j = c.get_join_list.get_item( a[ 1 ] ) # a[1]: μ̾
            next if j == nil
            e = j.get_rhs                          # composite θΥαդμ
            ele = e.get_elements
            if ele[0] == :OP_DOT then
              t = ele[1][1]
              c2 = j.get_cell
              next if c2 == nil
              nm = c2.get_name.to_sym
              rhs = Expression.new( [:OP_DOT, [:IDENTIFIER, Token.new( nm, t.file, t.lineno, t.col )], ele[2]] )
            else
              # mikan ե б
              Generator.error( "#{a[0].get_name}.#{a[1]}: self allocator not supported for array entry port" )
            end

            @alloc_list << [a[2],nil,a[3],a[4],rhs]
          }
        end

        # ץȥꤵƤΤȿǤ
        @entry_array_max_subscript.each{ |port,name|
          set_entry_inner_port_max_subscript( port, name )
        }
      else
#       check_join  compositecelltype ˸ƤФ
        @f_def = true
      end
    end
  end

  def set_f_ref
    @f_ref = true

    # composite 򻲾Ȥ줿Ȥˤ
    # ΤȤʤ̤ȤǤ٤ΤޤǻȤ줿Ȥˤʤ
    if @cell_list then
      @cell_list.each{ |cn,cell|
        cell.set_f_ref
      }
    end
  end

  #=== Ҥ
  # STAGE:  B
  #
  #    bnf.y.rb  statement_specifiler_list
  #spec_list::      [ :ALLOCATOR, [ [ ep_name, subscript, func_name, param_name, expr ], ... ] ]
  #                     s[0]      s[1]   a[0]     a[1]       a[2]        a[3]     a[4]
  #    ˻ꤵ줿
  #    a[1]  subscript ϤΥ᥽åɤ Expression  Integer ɾ
  #    ¦륢ƤӸη
  #    ƤӸ¦ Port  create_allocator_join ˤ
  def set_specifier_list( spec_list )
    return if spec_list == nil  # ʤв⤷ʤ

    spec_list.each{ |s|
      case s[0]             # statement_specifier
      when :ALLOCATOR       # [allocator(ePort.func.param=allocCell.eA,ePort.func2.param=allocCell.eA)]
        s[1].each { |a|     # alloc_list : allocator  ',' Ƕڤ줿ʬ
          cp_name = "#{a[0]}_#{a[2]}_#{a[3]}".to_sym    # ƤӸ̾'=' κդ '.' Ѥ '_' Ϣ
          # p "#{a[0]} #{a[2]} #{a[3]} #{cp_name}"
          if a[1] then
            subscript = a[1].eval_const nil
            a[1] = subscript
          else
            subscript = nil
          end
          # ƤӸη
          join = Join.new( cp_name, subscript, a[4] )
          Cell.new_join( join )
          @alloc_list << a 
        }
      else
        Generator.error( "'#{s[0]}': unknown specifier for cell" )
      end
    }
  end

  def get_allocator_list
    @alloc_list
  end

  def add_compositecelltypejoin join
    @compositecelltypejoin_list.add_item join
  end

  #===  cell  composite 륿פΥѤ clone 
  #name::        string :  cell ̾  (cell tComposite cell1 Ǥ cell1)
  #global_name:: string :  cell  global_name 
  #join_array::  Join[] : composite  cell  join ǡ cell б
  #ct_name::     string : ƥΥ륿̾
  #Υ᥽åɤ CompositeCelltype  expand ƽФ
  def clone_for_composite( name, global_name, join_array, ct_name )

    # debug
    # print "cell.clone_for_composite : cloning: #{@name} #{global_name}\n"

    @my_clone = self.clone
    @@cloned_cell_list[ self ] = @my_clone

    # clone ˻̾Ĵ
    @my_clone.set_cloned( name, global_name, join_array, ct_name )
    Namespace.new_cell( @my_clone )

    # @celltype == nil ϰ˥륿̤顼
    if @f_def == true && @celltype != nil && ! @celltype.instance_of?( CompositeCelltype ) then

      # celltype ϿʥоݤȤʤ
      @celltype.new_cell( @my_clone )
    end

    return @my_clone
  end

  #=== clone 줿˻̾Ĵ
  #name::        string :  cell ̾  (cell tComposite cell1 Ǥ cell1)
  #global_name:: string :  cell  global_name
  #join_array::  Join[] : composite  cell  join ǡ cell б
  #parent_ct_name:: string : ƥΥ륿̾composite 륿ס
  #  Υ᥽åɤϤ clone_for_composite ƽФ졢clone 줿
  def set_cloned( name, global_name, join_array, parent_ct_name )

    # debug
    # print "cell.set_cloned : global_name: #{global_name}  name: #{name}  @name: #{@name}\n"

    @global_name = "#{global_name}_#{@name}"
    @name = "#{name}_#{@name}"
    @region = Region.get_current
    @b_generate = @region.is_generate?
    # p "#{@name} #{@region.get_name} #{Region.get_current.get_name}"

    @in_composite = false
    @f_cloned = true

    # join_list : NamedList  clone 
    # p "set_cloned: #{@celltype.get_name} #{@name}"
    @join_list = @join_list.clone_for_composite( parent_ct_name, name )

    # ΥΥХ̾Ϳ
    # C_EXP $id$ ִϤΥ̾ˤʤ
    join_array.each { |j|
      @join_list.change_item j
    }

    # clone 褦Ȥ륻뤬 composit 륿ס
    if @celltype.instance_of?( CompositeCelltype ) then
      # composite cell ƵŪŸ
      @cell_list = @celltype.expand( @name, @global_name, @join_list )
    end

  end

  #===  clone 줿 cell  join_list αդѹ
  #  ƤӸαդ cell ¾ clone 줿 cell ִ
  def change_rhs_port

    @join_list.get_items.each { |j|
      j.change_rhs_port( @@cloned_cell_list, @celltype )
    }

    # debug
    # print "Cell change_rhs_port: global_name: #{@global_name}\n"

    if @celltype.instance_of?( CompositeCelltype ) then

      # ҤΥˤĤƤѹ
      @cell_list.each{ |name,c|
        c.change_rhs_port
      }
    end
  end

  def get_f_def
    @f_def
  end

  def get_f_ref
    if @f_ref
      return true
    else
      return false
    end
  end

  def get_name
    @name
  end

  def get_local_name
    @local_name
  end

  def get_global_name
    @global_name
  end

  def get_region
    @region
  end

  def self.get_current
    @@current_object
  end

  def is_generate?
    @b_generate
  end

  # composite cell  port б cell  port ̾ʥ󥯻ɬפ̾
  def get_real_global_name port_name
    if @celltype.instance_of?( CompositeCelltype ) then

      # debug
      # print "get_real_global_name: cell name: #{@name} #{@local_name} #{@global_name} #{port_name}\n"
      # @cell_list.each{ |n,c|
      #   print "   name: #{n}"
      #   print " get_name: #{c.get_name} local_name: #{c.get_local_name}"  if c
      #   print "\n"
      # }

      cj = @celltype.find_export( port_name )

      # debug
      # print " composite join name: #{cj.get_name}  cell: #{cj.get_cell_name}  cell elem: #{cj.get_cell_elem_name}\n"

      name = @cell_list[ "#{cj.get_cell_name}" ].get_real_global_name( cj.get_cell_elem_name )
      return name

    else
      # debug
      # print "  get_real_global_name: cell name: #{@global_name}\n"

      return @global_name
    end
  end

  #=== μ port_name ФºݤΥ̾̾ '_' Ϣ
  #    namespace ̾ + '_' + ̾ + '_' + ̾   ʤΥ뤬 composite ʤŸΥ̾̾
  def get_real_global_port_name port_name

    # composite 
    if @celltype.instance_of?( CompositeCelltype ) then

      # debug
      # print "get_real_global_port_name: cell name: #{@name} #{@local_name} #{@global_name} #{port_name}\n"
      # @cell_list.each{ |n,c|
      #   print "   name: #{n}"
      #   print " get_name: #{c.get_name} local_name: #{c.get_local_name}"  if c
      #   print "\n"
      # }

      # 륿 port_name  CompositeCelltypeJoin õʥʳǤɬĤ
      cj = @celltype.find_export( port_name )

      # debug
      # print "   composite join name: #{cj.get_name}  cell: #{cj.get_cell_name}  cell elem: #{cj.get_cell_elem_name}\n"

      # composite ΥФƵŪ get_real_global_port_name Ŭ
      name = @cell_list[ "#{cj.get_cell_name}" ].get_real_global_port_name( cj.get_cell_elem_name )
      return name

    else
      # debug
      # print "get_real_global_port_name:  cell name: #{@global_name}\n"

      return "#{@global_name}_#{port_name}"
    end
  end

  #=== PORT (celltype ) 
  def get_real_port( port_name )

    # composite 
    if @celltype.instance_of?( CompositeCelltype ) then

      # 륿 port_name  CompositeCelltypeJoin õʥʳǤɬĤ
      cj = @celltype.find_export( port_name )

      # composite ΥФƵŪ get_real_port Ŭ
      port = @cell_list[ "#{cj.get_cell_name}" ].get_real_port( cj.get_cell_elem_name )
      return port
    else

      return @celltype.find( port_name )
    end
  end

  #=== cell 
  #    composite ǤʤмʬȤ֤
  def get_real_cell( port_name )

    # composite 
    if @celltype.instance_of?( CompositeCelltype ) then

      # 륿 port_name  CompositeCelltypeJoin õʥʳǤɬĤ
      cj = @celltype.find_export( port_name )

      # composite ΥФƵŪ get_real_port Ŭ
      cell = @cell_list[ "#{cj.get_cell_name}" ].get_real_cell( cj.get_cell_elem_name )
      return cell
    else

      return self
    end
  end

  def get_internal_port_name port_name
    if @celltype.instance_of?( CompositeCelltype ) then
      cj = @celltype.find_export( port_name )
#      return "#{@name}_#{cj.get_cell.get_internal_port_name cj.get_cell_elem_name}"
      return cj.get_cell.get_internal_port_name( cj.get_cell_elem_name )
    else

      # debug
      # print "  get_global_port_name: cell port: #{@global_name}_#{port_name}\n"

      return "#{@global_name}_#{port_name}"
    end
  end

  def get_celltype
    @celltype
  end

  def get_join_list
    @join_list
  end

  def set_id id
    @id = id
    @prototypes.each{ |pc|
      pc.set_id id
    }
  end

  def get_id
    @id
  end

  #=== źκͤ
  def set_entry_port_max_subscript( port, num )
    subscript = @entry_array_max_subscript[port]

    if subscript == nil || num > subscript then
      @entry_array_max_subscript[port] = num
      set_entry_inner_port_max_subscript( port, num )
    end
  end

  #=== composite ¦μźκͤ
  def set_entry_inner_port_max_subscript( port, num )
    if @cell_list == nil then
      return    # ץȥƤʤơ¦뤬ŸƤʤ
    end

    # composite ¦Υ
    if @celltype.instance_of? CompositeCelltype then
      cj = @celltype.find_export port.get_name
      if cj && @cell_list[ cj.get_cell_name.to_s ] then
        inner_cell = @cell_list[ cj.get_cell_name.to_s ]
        ct = inner_cell.get_celltype
        if ct then
          inner_port = ct.find( cj.get_cell_elem_name )
          inner_cell.set_entry_port_max_subscript( inner_port, num )
        end
      end
    end
  end

  #=== źκ֤ͤ
  # Ĺ +1 
  # 1Ĥʤ -1 ֤
  def get_entry_port_max_subscript( port )
    subscript = @entry_array_max_subscript[port]
    if subscript == nil then
      subscript = -1
    end
    return subscript
  end

  #===  (Join)Υå
  #     Join ϸƤӸηޤ attribute ν
  #
  #  mikan Υ᥽åɤϡʲΣĤΥåʤ뤬ʬ䤷ۤŬڤĹΥ᥽åɤˤʤ
  #  졼
  #  ̤θƤӸΥå
  #  ݥ󥿷ǽΥå
  #  ̤°Υå
  def check_join

    # celltype ʤХåʤʴ˥顼
    return if @celltype == nil

    # debug
    # if @compositecelltypejoin_list
    #   p "check_join"
    #   @compositecelltypejoin_list.get_items.each { |cj| p "#{cj.get_name} #{cj.get_name.object_id}" }
    # end

    # relay allocator 
    if @celltype.instance_of? Celltype then
      @celltype.get_port_list.each { |p|
        ail = p.get_allocator_instance
        if ail then
          if p.get_array_size then
            # mikan relay allocator  array бǤƤ褤ΤǤϡ
            Generator.error( "array not supported for relay allocator" )
            next
          end
          ail.each{ |name,ai2|
            # ai2 = [ :SELF_ALLOC|:RELAY_ALLOC, func_name, param_name, rhs_cp_name, rhs_func_name, rhs_param_name ]
            if ai2[0] == :RELAY_ALLOC then
              ja = @join_list.get_item( "#{ai2[3]}_#{ai2[4]}_#{ai2[5]}" )
              if ja == nil then

                found = false
                # composite ǳ˷礵Ƥ뤫
                if @in_composite then
                  @compositecelltypejoin_list.get_items.each { |cj|
                  p cj.get_cell_name, @name, cj.get_cell_elem_name, "#{ai2[3]}_#{ai2[4]}_#{ai2[5]}".to_sym, ""
                    if cj.get_cell_name == @name &&
                       cj.get_cell_elem_name == "#{ai2[3]}_#{ai2[4]}_#{ai2[5]}".to_sym then
                      found = true
                    end
                  }
                end

                if found == false then
                  Generator.error( "'#{ai2[3]}_#{ai2[4]}_#{ai2[5]}': not joined. cannot create internal join for relay allocator" )
                  # join ̤Ǥ뤳ȤΥ顼٤Ǥ
                end
                next
              end

#            ja3 = nil
#            @join_list.get_items.each { |ja4|
#p ja4.get_definition.get_name
#              if( ja4.get_definition.get_name == p.get_name )then
#p "ara"
#                ja3 = ja4
#                break
#              end
#            }
#            am = ja3.get_array_member2
              am = nil
#            p "am: #{ja.get_name} #{am}"
              if am then
                am.each{ |ja2|
                  rhs = ja2.get_rhs
                  subscript = ja2.get_subscript
                  join = Join.new( "#{p.get_name}_#{ai2[1]}_#{ai2[2]}", subscript, rhs )
                  # p ( "#{p.get_name}_#{ai2[1]}_#{ai2[2]}", subscript, rhs )
                  new_join( join )
                  @alloc_list << [ p.get_name, subscript, ai2[1], ai2[2], rhs ]
                }
              else
                join = Join.new( "#{p.get_name}_#{ai2[1]}_#{ai2[2]}", nil, ja.get_rhs )
                new_join( join )
                @alloc_list << [ p.get_name, nil, ai2[1], ai2[2], ja.get_rhs ]
              end
              # p "#{p.get_name}_#{ai2[1]}_#{ai2[2]} #{ai2[3]}_#{ai2[4]}_#{ai2[5]}"
            end
          }
        end
      }
    else#if @celltype.instance_of? CompositeCelltype then
      
    end # if @celltype.instance_of? Celltype

    # ̤θƤӸΥå
    @celltype.get_port_list.each { |p|

      # ƤӸǤʤСåʤ
      next if p.get_port_type != :CALL

      # debug
      # print "check_join: #{@name} #{get_celltype.get_name} #{p.get_name}\n"

      # ꥹȤ椫ƤӸ̾˰פΤ
      j = @join_list.get_item( p.get_name )

      if j == nil then
        # ̤θƤӸ

        # composite celltype ξ硢composite celltype  export ƤӸ˷礵Ƥ뤫õ
        found = false
        if @in_composite then
          # composite celltype  export Τ٤Ƥõ
          # export Ταͤõ get_item Ǥϥ
          @compositecelltypejoin_list.get_items.each{ |cj|
            # ƤӸ̾ composite  export ̾ϰפ뤫
            if p.get_name == cj.get_cell_elem_name then
              found = true
            end
          }
        end

        # ƤӸξ optional ƤǤʤˡ
        if ! found && ! p.is_require? && ! p.is_optional? then
          if ! p.is_allocator_port? then
            Generator.error( "call port '#{p.get_name}' not initialized in cell '#{@name}'" )
          else
            Generator.error( "call port '#{p.get_name}' not initialized in cell '#{@name}'. this call port is created by tecsgen. check allocator specifier" )
          end
        end
      elsif p.get_array_size.kind_of? Integer then
        # źƤӸξ硢٤ƤźǤƤ뤫å

        am = j.get_array_member2
        if( am )then
          # join 

          # ƤӸǤ礭
          length = p.get_array_size

          # 礭ƤӸȷǰפ뤫
          if am.length != length then
            if ! p.is_optional? || am.length >= length then
              # optional ξ硢ǿʤΤ OK
              Generator.error( "#{p.get_name}: array initializer too many or few, #{am.length} for #{length}" )
            end

            # am Ǥ nil ɲäƤ (#_CPA_# Υǿʬ)
            i = am.length
            while i < length
              am << nil
              i += 1
            end
          end

#          # Ǥȴʤå
#          if am.length < length then  # ʤ˥顼ǤΤϰϤǥå
#            length = am.length
#          end
          i = 0
          while( i < length )
            if am[i] == nil then
              if ! p.is_optional? then
                Generator.error( "#{p.get_name}[#{i}]: not initialized" )
              end
            else
              # ʤ꡼ؤη礫å
              if (! @in_composite) && @b_generate then
                am[i].check_region2
              end
            end
            i += 1
          end

        # else
        # join ǤС˥顼
        end
      elsif j.get_array_member
        # źʤƤӸξ
        am = j.get_array_member2
        length = am.length
        i = 0
        while i < length
          if am[i] == nil then
            if ! p.is_optional? then
              Generator.error( "#{p.get_name}[#{i}]: not initialized" )
            end
          end
          i += 1
        end

        # ʤ꡼ؤη礫å
        if (! @in_compoiste) && @b_generate then
          am.each { |join|
            if join then
              join.check_region2
            end
          }
        end
      else
        # ƤӸפǤʤ

        # ʤ꡼ؤη礫å
        if (! @in_composite) && @b_generate then
          j.check_region2
        end

      end # j != nil
    }

    # ݥ󥿷ǽΥå
    (@celltype.get_attribute_list+@celltype.get_var_list).each { |a|
      if a.get_size_is then

        if a.instance_of? CompositeCelltypeJoin then
          # ˥顼ˤʤäƤ
          # Generator.error( "size_is pointer cannot be exposed for composite attribute" )
          next
        end

        if( ! a.get_type.kind_of?( PtrType ) ) then
          Generator.error( "#{a.get_name}: size_is specified for non-pointer type" )
        else
          size = a.get_size_is.eval_const( @join_list, @celltype.get_name_list )
          a.get_type.set_scs( a.get_size_is, nil, nil )
          if( ! size.kind_of? Integer )then               # C_EXP βǽ
            # mikan ¿ʬǤΥ顼ȯסeval_const ѿ¸ߤʤŬڤʤɤΥ顼ˤʤϤ
            Generator.error( "#{a.get_name}: size_is arg not constant" )
          else
            j = @join_list.get_item( a.get_identifier )
            if j then
              ini = j.get_rhs
              if ini then
                if ! ini.instance_of?( Array ) then
                  Generator.error( "unsuitable initializer, need array initializer" )
                elsif size < ini.length then
                  Generator.error( "too many initializer for array, #{ini.length} for #{size}" )
                else
                  # a.get_type.set_scs( a.get_size_is, nil, nil )
                end
              end
            end
          end
        end
      end
    }

    # ̤°å
    @celltype.get_attribute_list.each { |a|
      b_init = false
      # self.show_tree 1
      if a.get_initializer then                               # 륿פǽƤ
        b_init = true
        # @in_composite  export ƤˤϡνͤϻȤʤ
        # export Ƥ롢ʤ˴ؤ餺Ƥ뤳Ȥݾڤ
      elsif @join_list.get_item( a.get_name ) then            # ǽƤ
        b_init = true
      elsif @in_composite && @compositecelltypejoin_list then
        # ° export Ƥ뤫Ĵ٤롣export Ƥ̤ȤϤʤ
        @compositecelltypejoin_list.get_items.each{ |cj|
          # °̾ composite  export ̾ϰפ뤫
          if a.get_name.to_sym == cj.get_cell_elem_name.to_sym then
            b_init = true    # ° export ƤΤǡȤꤢ̤ȤϤʤ
          end
        }
      end

      if b_init == false then
          Generator.error( "attribute '#{a.get_name}' not initialized in cell '#{@name}'" )
      end
   
    }
  end

  def set_require_join( cp_name, cell, port )
    if @join_list.get_item( cp_name ) then
      Generator.warning( "#{cp_name} : require call port overridden in #{@name}" )
    else
      # require  join (ƤӸη)
      rhs = Expression.new( [ :OP_DOT, [ :IDENTIFIER, Token.new( cell.get_name, nil, nil, nil ) ],
                              Token.new( port.get_name, nil, nil, nil ) ] )
      join = Join.new( cp_name, nil, rhs )
      self.new_join( join )
    end
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Cell: name: #{@name} in_composite: #{@in_composite} def: #{@f_def} ref: #{@f_ref} gen: #{@b_generate} cloned: #{@f_cloned}"
    (indent+1).times { print "  " }
    puts "id: #{@id}  global_name: #{@global_name}  region: #{@region.get_name} #{self}"

    if @celltype then
      (indent+1).times { print "  " }
      puts "celltype: #{@celltype.get_name}"
    end
    @join_list.show_tree( indent + 1 )
    @entry_array_max_subscript.each{ |port, num|
      (indent+1).times { print "  " }
      puts "entry array #{port.get_name}: max subscript=#{num}"
    }
    if @cell_list then   #  @cell_list  nil ʤΤ Bug
      (indent+1).times { print "  " }
      puts "cloned cell list:"
      @cell_list.each { |n,c|
        (indent+2).times { print "  " }
        puts "inner cell : #{n} = #{c.get_name}"
      }
    end
    if @compositecelltypejoin_list then
      @compositecelltypejoin_list.get_items.each{ |cj|
        cj.show_tree( indent+1 )
      }
    end
    if @alloc_list.length > 0 then
      (indent+1).times { print "  " }
      puts "allocator list:"
      @alloc_list.each { |a|
        cp_name = "#{a[0]}_#{a[2]}_#{a[3]}"
        if a[1] then
          subscript = "[#{a[1].eval_const nil}]"
        else
          subscript = ""
        end
        # ƤӸη
        (indent+2).times { print "  " }
        puts "#{cp_name}#{subscript} = #{a[4]}"
      }
    end
  end

end

class CompositeCelltype # < Nestable
# @name:: str
# @global_name:: str
# @cell_list:: NamedList   Cell
# @export_name_list:: NamedList : CompositeCelltypeJoin
# @port_list:: CompositeCelltypeJoin[]
# @attr_list:: CompositeCelltypeJoin[]
# @b_singleton:: bool : 'singleton' specified
# @b_active:: bool : 'active' specified
# @real_singleton:: bool : has singleton cell in this composite celltype
# @real_active:: bool : has active cell in this composite celltype
# @name_list:: NamedList item: Decl (attribute), Port ݡ
# @self_allocator_list:: [ [cell, internal_cp_name, port_name, func_name, param_name], ... ]

  @@nest_stack_index = -1
  @@nest_stack = []
  @@current_object = nil

  def self.push
    @@nest_stack_index += 1
    @@nest_stack[ @@nest_stack_index ] = @@current_object
    @@current_object = nil
  end

  def self.pop
    @@current_object = @@nest_stack[ @@nest_stack_index ]
    @@nest_stack_index -= 1
    if @@nest_stack_index < -1 then
      raise "TooManyRestore"
    end
  end


  def initialize( name )
    @name = name
    @cell_list = NamedList.new( nil, "in composite celltype #{name}" )
    @export_name_list = NamedList.new( nil, "export in composite celltype #{name}" )
    @name_list = NamedList.new( nil, "in composite celltype #{name}" )
    @@current_object = self

    @b_singleton = false
    @real_singleton = nil
    @b_active = false
    @real_active = nil

    if #{Namespace.get_global_name} == "" then
      @global_name = @name
    else
      @global_name = "#{Namespace.get_global_name}_#{@name}"
    end

    Namespace.new_compositecelltype( self )

    @port_list = []
    @attr_list = []
    @self_allocator_list = []
  end

  def self.end_of_parse
    @@current_object.end_of_parse
    @@current_object = nil
  end

  def end_of_parse

    # singleton ˴ؤå
    if @b_singleton && @real_singleton == nil then
      Generator.warning( "#{@name} : specified singleton but has no singleton in this celltype" )
    elsif ! @b_singleton && @real_singleton != nil then
      if ! @b_singleton then
        Generator.error( "#{@name} must be singleton. inner cell '#{@real_singleton.get_name}' is singleton" )
      end
    end

    # active ˴ؤå
    if @b_active && @real_active == nil then
      Generator.error( "#{@name} : specified active but has no active in this celltype" )
    elsif ! @b_active && @real_active != nil then
      Generator.error( "#{@name} must be active. inner cell '#{@real_active.get_name}' is active" )
    end

    # cell ̤θƤӸʤå
    @cell_list.get_items.each{ |c|
      c.check_join
    }

    # ƤӸηˤĤơexport ξʤå
    @port_list.each{ |p|
      p.check_dup_init
    }

    # ٤ƤΥݡбƤӸ°¸ߤ뤫å
    @name_list.get_items.each{ |n|
      if( @export_name_list.get_item( n.get_name ) == nil )then
        Generator.error( "#{n.get_name} : cannot export, nothing designated" )
      end
    }

  end

 ### cell (CompositeCelltype)
  def self.new_cell( cell )
    @@current_object.new_cell( cell )

  end

  def new_cell( cell )
    @cell_list.add_item( cell )
    if cell.get_celltype then    # nil ʤСǤ˥륿פʤ顼
      if cell.get_celltype.is_singleton? then
        @real_singleton = cell
      end
      if cell.get_celltype.is_active? then
        @real_active = cell
      end
    end
  end

 ### join
  def self.new_join( export_name, internal_cell_name,
			 internal_cell_elem_name, type )
    @@current_object.new_join( export_name, internal_cell_name,
					 internal_cell_elem_name, type )
    
  end

  #=== CompositeCelltypeJoin 
  #export_name:: string : ˸̾
  #internal_cell_name:: string : ̾
  #internal_cell_elem_name:: string : ̾ʸƤӸ̾̾°̾Τ줫
  #type::  :CALL, :ENTRY, :ATTRIBUTE Τ줫ʹʸǤȤƤ٤Ρ
  #RETURN:: Decl | Port : ݡ
  # new_join 
  #   cCall => composite.cCall; attr = composite.attr; composite.eEnt => cell2.eEnt;
  # ιʸǤνиФƸƤӽФ
  def new_join( export_name, internal_cell_name,
		 internal_cell_elem_name, type )

    # p "new_join: #{export_name} #{internal_cell_name} #{internal_cell_elem_name}"

    cell = @cell_list.get_item( internal_cell_name )
    if cell == nil then
      Generator.error( "#{internal_cell_name} not found in #{@name}" )
      return
    end

    celltype = cell.get_celltype
    return if celltype == nil	# celltype == nil ʤ餹Ǥ˥顼

    # Υ륿פбǤõ
    # Υ᥽åɤϡʸ塢ƤӸ°ҤǤս꤫ƽФ
    # ʸθƽФ֡ʵҰ֡ˤȡǤбΤå
    obj = celltype.find( internal_cell_elem_name )
    if obj.instance_of?( Decl ) then
      if obj.get_kind == :VAR then
        Generator.error( "'#{internal_cell_elem_name}' : cannot export var" )
        return
      elsif type != :ATTRIBUTE then
        Generator.error( "'#{export_name}' : exporting attribute. write in cell or use '=' to export attribute" )
        # return Υ顼򤱤뤿˽³ԤդäƤߤ
      end
    elsif obj.instance_of?( Port ) then
      if obj.get_port_type != type then
        Generator.error( "'#{export_name}' : port type mismatch. #{type} type is allowed here." )
        # return Υ顼򤱤뤿˽³ԤդäƤߤ
      end
    end

    # ݡȰפ뤫ɤå
    obj2 = @name_list.get_item( export_name )
    if( obj2 == nil )then
      Generator.error( "#{export_name} has no export definition" )
    elsif obj2.instance_of?( Decl ) then
      if( ! obj.instance_of? Decl )then
        Generator.error( "#{export_name} is port but previously defined as an attribute" )
      elsif ! obj.get_type.equal? obj2.get_type then
        Generator.error( "#{export_name} : type '#{obj.get_type.get_type_str}#{obj.get_type.get_type_str_post}' mismatch with pprevious definition'#{obj2.get_type.get_type_str}#{obj2.get_type.get_type_str_post}'" )
      end
    elsif obj2.instance_of?( Port ) then
      if( obj.instance_of? Port )then
        if( obj.get_port_type != obj2.get_port_type )then
          Generator.error( "#{export_name} : port type #{obj.get_port_type} mismatch with previous definition #{obj2.get_port_type}" )
        elsif obj.get_signature != obj2.get_signature then
          if obj.get_signature != nil && obj2.get_signature != nil then
            # nil ʤд˥顼ʤΤ𤷤ʤ
            Generator.error( "#{export_name} : signature '#{obj.get_signature.get_name}' mismatch with previous definition '#{obj2.get_signature.get_name}'" )
          end
        elsif obj.get_array_size != obj2.get_array_size then
          Generator.error( "#{export_name} : array size mismatch with previous definition" )
        elsif obj.is_optional? != obj2.is_optional? then
          Generator.error( "#{export_name} : optional specifier mismatch with previous definition" )
        end
      else
        Generator.error( "#{export_name} is an attribute but previously defined as a port" )
      end
    end

    join = CompositeCelltypeJoin.new( export_name, internal_cell_name,
				 internal_cell_elem_name, cell, obj2 )
    cell.add_compositecelltypejoin join

    # debug
    # print "compositecelltype join: add #{cell.get_name} #{export_name} = #{internal_cell_name}.#{internal_cell_elem_name}\n"

    if obj.instance_of?( Decl ) then
      # attribute
      @attr_list << join
    else
      # call/entry port
      @port_list << join
    end

    # join  @export_name_list ϿʽʣåȤȤˡǹԤ CompositeCelltypeJoin  clone 
    if obj.instance_of?( Decl ) && @export_name_list.get_item( export_name ) then
      # ¸ߤ롣ɲäʤͤǤϡ@export_name_list Ʊ̾ޤޤ뤳Ȥ롣
    elsif obj.instance_of?( Port ) && obj.get_port_type == :CALL && @export_name_list.get_item( export_name ) then
      # ¸ߤ롣ɲäʤͤǤϡ@export_name_list Ʊ̾ޤޤ뤳Ȥ롣
    else
      @export_name_list.add_item( join )
    end

    # export ݡȤ˴ޤޤ send/receive ѥ᡼Υ(allocator)ƤӸ򥻥ȷ
    if obj2.instance_of? Port then
      obj2.each_param{ |port, fd, par|
        case par.get_direction                        #  (in, out, inout, send, receive )
        when :SEND, :RECEIVE
          cp_name = "#{port.get_name}_#{fd.get_name}_#{par.get_name}".to_sym     # ƤӸ̾
          #            ݡ̾         ؿ̾         ѥ᡼̾
          cp_internal_name = "#{internal_cell_elem_name}_#{fd.get_name}_#{par.get_name}".to_sym
          # p "cp_name: #{cp_name} cp_internal_name: #{cp_internal_name}"
          if cell.get_join_list.get_item cp_internal_name then    # Ѥ ?
            # եξ
            # ѤΥƤӸä
            @name_list.del_item( @name_list.get_item( cp_name ) )
            @self_allocator_list << [ cell, cp_internal_name, port.get_name, fd.get_name, par.get_name ]
          else
            new_join( cp_name, internal_cell_name, cp_internal_name, :CALL )
          end
        end
      }
    end

    # ݡ֤
    return obj2
  end

  def self.has_attribute? attr
    @@current_object.has_attribute? attr
  end

  def has_attribute? attr
    @name_list.get_item( attr ) != nil
  end

  def self.new_port port
    @@current_object.new_port port
  end

  #=== new_port
  def new_port port
    # p "new_port: #{port.get_name}"
    @name_list.add_item port

    # export ݡȤ˴ޤޤ send/receive ѥ᡼ΥƤӸ export ƥݡȤɲ
    # λǤϥեɤȽǤǤʤΤǡȤꤢƤ
    port.each_param { |port, fd, par|
      case par.get_direction                        #  (in, out, inout, send, receive )
      when :SEND, :RECEIVE
        if par.get_allocator then
          cp_name = "#{port.get_name}_#{fd.get_name}_#{par.get_name}".to_sym     # ƤӸ̾
          #           ݡ̾          ؿ̾         ѥ᡼̾
          alloc_sig_path = [ par.get_allocator.get_name ]  # mikan Namespace ƤӸΥ˥
          array_size = port.get_array_size            # ƤӸޤϼΥ
          created_port = Port.new( cp_name, alloc_sig_path, :CALL, array_size ) # ƤӸ
          created_port.set_allocator_port( port, fd, par )
          new_port( created_port )           # 륿פ˿ƤӸɲ
        # else
        #   already error
        end
      end
    }
  end

  def self.new_attribute attr
    @@current_object.new_attribute attr
  end

  #=== new_attribute for CompositeCelltype
  #attribute:: [Decl]
  def new_attribute( attribute )
    attribute.each { |a|
      if a.get_size_is then
        Generator.error( "#{a.get_name}: size_is pointer cannot be exposed for composite attribute" )
      end
       @name_list.add_item( a )
       if a.get_initializer then
         a.get_type.check_init( a.get_identifier, a.get_initializer, :ATTRIBUTE )
       end
    }
  end

  # false : if not in celltype definition, nil : if not found in celltype
  def self.find( name )
    if @@current_object == nil then
      return false
    end
    @@current_object.find name
  end

  def find name
    cell = @cell_list.get_item( name )
    return cell if cell

# p "#{name}, #{@name_list.get_item( name )}"
    return @name_list.get_item( name )

    # 
#    cj = @export_name_list.get_item( name )
#p "#{name}, #{cj.get_port_decl}"
#    if cj then
#      return cj.get_port_decl
#    else
#      return nil
#    end
  end

  #=== export  CompositeCelltypeJoin 
  #name:: string:
  # attribute ξ硢Ʊ̾Фʣ¸ߤǽ뤬ǽΤΤ֤ʤ
  def find_export name
    return @export_name_list.get_item( name )
  end

  #=== composite celltype  cell Ÿ
  #name:: string: Composite cell ̾
  #global_name:: string: Composite cell  global name (C ̾)
  #join_list:: NamedList : Composite cell Ф Join  NamedList
  def expand( name, global_name, join_list )

    # debug
    # print "expand composite: #{@name} name: #{name}  global_name: #{global_name}\njoin_list:\n"
    # join_list.get_items.each{ |j|
    #  print "   #{j.get_name} #{j}\n"
    # }

    # Ÿ clone 줿Υꥹȡդ Cell (composite ξ composite  cell  clone)
    clone_cell_list = {}

    #  composite Τ٤Ƥ cell ˤĤ
    @cell_list.get_items.each { |c|

      # debug
      # print "expand : cell #{c.get_name}\n"

      # Join 
      ja = []

      # CompositeCelltype  export ƤӸ°ΥꥹȤˤĤ
      # @export_name_list.get_items.each{ |cj|	# cj: CompositeCelltypeJoin
      # ͤǤϡ@export_name_list äƤʤ attr ꤦ
      (@port_list+@attr_list).each{ |cj|	# cj: CompositeCelltypeJoin

        # debug
        # print "        cj : #{cj.get_name}\n"

        # CompositeCelltypeJoin (export) оݥ뤫
        if cj.match?( c ) then

          # оݥ CompositeCelltype  export  Join (attribute ޤ call port)
          j = join_list.get_item( cj.get_name )

          # debug
          # if j then
          #  print "expand : parent cell: #{name} child cell: #{c.get_name}:  parent's export port: #{cj.get_name}  join: #{j.get_name} #{j}\n"
          # else
          #  print "expand : parent cell: #{name} child cell: #{c.get_name}:  parent's export port: #{cj.get_name}  join: nil\n"
          # end

          if j then
            # ƤӸ°ξ
            #  ComositeCell ѤΤ(j) оݥѤ clone
            # p "expand: cloning Join #{j.get_name} #{@name} #{name}"
            jc = j.clone_for_composite( @name, name )
                                        # celltype_name, cell_name

            # debug
            # p "cn #{jc.get_name} #{cj.get_cell_elem_name}"

            # оݥθƤӸޤ°̾ѹ
            jc.change_name( cj.get_cell_elem_name )

            # оݥФ Join 
            ja << jc
          end

          # debug
          # print "\n"
        end
      }

      # debug
      # print "expand : clone #{name}_#{c.get_name}\n"

      #  clone 
#      clone_cell_list[ "#{name}_#{c.get_name}" ] =  c.clone_for_composite( name, global_name, ja )
      clone_cell_list[ "#{c.get_local_name}" ] =  c.clone_for_composite( name, global_name, ja, @name )

    }

    # debug
    # clone_cell_list.each { |nm,c|
    #   print "  cloned: #{nm} = #{c.get_global_name}\n"
    # }

    return clone_cell_list
  end

  def set_specifier( spec )
    spec.each { |s|
      case s
      when :SINGLETON
        @b_singleton = true
      when :IDX_IS_ID
        Generator.warning( "#{@name} : idx_is_id is ineffective for composite celltype" )
      when :ACTIVE
        @b_active = true
      end
    }
  end

  def get_name
    @name
  end

  def get_port_list
    @port_list
  end

  def get_attribute_list
    @attr_list
  end

  def get_var_list
    []   # ֤
  end

  def get_self_allocator_list
    @self_allocator_list
  end

  def is_singleton?
    @b_singleton
  end

  def is_active?
    @b_active
  end

  #=== ƥ֤ǤϤʤ
  # active ǤϤʤ˲äƤΥ륿פ inactive ξ inactive
  # Υ뤬 active ޤ factory äƤ
  def is_inactive?
    if @b_active == false then
      @cell_list.get_items.each{ |c|
        if c.get_celltype && c.get_celltype.is_inactive? == false then
          # c.get_celltype == nil ξϥ륿̤ǤǤ˥顼
          return false
        end
      }
      return true
    else
      return false
    end
  end

  def get_id_base
    raise "get_id_base"
  end

  #=== ƤӸ
  #    send, receive ΥƽФθƤӸ
  def generate_allocator_port
    @port.each { |port|
      # ݡȤΤ٤ƤΥѥ᡼é
      port.each_param { |port, fd, par|
        case par.get_direction                        #  (in, out, inout, send, receive )
        when :SEND, :RECEIVE
          cp_name = "#{port.get_name}_#{fd.get_name}_#{par.get_name}".to_sym     # ƤӸ̾
          #           ݡ̾          ؿ̾         ѥ᡼̾
          alloc_sig_path = [ par.get_allocator.get_name ]  # mikan Namespace ƤӸΥ˥
          array_size = port.get_array_size            # ƤӸޤϼΥ
          created_port = Port.new( cp_name, alloc_sig_path, :CALL, array_size ) # ƤӸ
          Celltype.new_port( created_port )           # 륿פ˿ƤӸɲ
        end
      }
    }
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "CompositeCelltype: name: #{@name}"
    (indent+1).times { print "  " }
    puts "active: #{@b_active}, singleton: #{@b_singleton}"
    @cell_list.show_tree( indent + 1 )
    (indent+1).times { print "  " }
    puts "name_list"
    @name_list.show_tree( indent + 2 )
    (indent+1).times { print "  " }
    puts "export_name_list"
    @export_name_list.show_tree( indent + 2 )
  end

end



#== ʸǡɽ饹ʥ륿פθƤӸ
class Port
# @name::  str
# @signature:: Signature
# @port_type::  :CALL, :ENTRY
# @array_size:: nil: not array, "[]": sizeless, Integer: sized array
#
# set_allocator_port ˤäꤵ롥ꤵ줿硢ΥݡȤϥݡȤǤ롣
# @allocator_port:: Port : θƤӸǤ븵ȤʤäƤӸޤϼ
# @allocator_func_decl:: Decl : θƤӸǤ븵ȤʤäƤӸޤϼδؿ
# @allocator_param_decl:: ParamDecl : θƤӸǤ븵ȤʤäƤӸޤϼΥѥ᡼
#
# set_specifier ˤäꤵ(
# @allocator_instance:: Hash : {"func_param" => [:SELF_ALLOC|:RELAY_ALLOC,  IDENTIFIER, IDENTIFIER, expression ],..}
# @allocator_instance_tmp:: Hash : {"func_param" => [:SELF_ALLOC|:RELAY_ALLOC,  IDENTIFIER, IDENTIFIER, expression ],..}
#                                                                             function    parameter   rhs
#
# @b_require:: bool : require ˤ줿 call port ξ true
# @b_has_name:: bool : require : ̾Υꥯ磻ƤӸ
# @b_inline:: bool : entry port Τ
# @b_optional:: bool : entry port Τ
#
# optimize::
# @celltype:: °륻륿
# @ref_port_list[]:: Port[] Ȥݡ (:ENTRY λΤߥåȤ)
#
# :CALL ξκŬ
# @b_VMT_useless:: bool                     # VMT ؿơ֥Ѥʤ
# @b_skelton_useless:: bool                 # ȥؿ   (true λؿƽФ)
# @b_cell_unique:: bool                     # ƤͣΥ
# @only_callee_port:: Port                  # ͣθƤݡ
# @only_callee_cell:: Cell                  # ͣθƤ襻 (@b_PEPDES_in_CB_useless = true λͭ)
#
# :ENTRY ξκŬʸƤӸŬƱѿ̾ѡ
# @b_VMT_useless:: bool                     # VMT ؿơ֥뤬
# @b_skelton_useless:: bool                 # ȥؿ

  def initialize( name, sig_path, port_type, array_size = nil )
    @name = name
    @port_type = port_type

    if array_size == "[]" then
#      if port_type == :ENTRY then
#        Generator.error( "#{name}: entry port: sizeless array not supported in current version" )
#      end
      @array_size = array_size
    elsif array_size then
      if array_size.kind_of? Expression then
        @array_size = array_size.eval_const(nil)
      else
        @array_size = array_size   # ϥƤӸξʸθƤӸǴɾѤߡ
      end
      if @array_size == nil then
        Generator.error( "Not constant expression #{array_size.to_s}" )
      end

      #if Integer( @array_size ) != @array_size then
      if ! @array_size.kind_of? Integer then
        Generator.error( "Not Integer #{array_size.to_s}" )
      end

    end

    object = Namespace.find( sig_path )
    if object == nil then
      # mikan signature ̾Դ
      Generator.error( "'#{sig_path}' signature not found" )
    elsif ! object.instance_of?( Signature ) then
      # mikan signature ̾Դ
      Generator.error( "'#{sig_path}' not signature" )
    else
      @signature = object

    end

    @ref_port_list = []

    @b_require = false
    @b_has_name = false
    @b_inline = false
    @b_optional = false

    if port_type == :CALL then
      # call port optimize
      @b_VMT_useless = false                     # VMT  (true λ VMT 𤹤뤳ȤʤƽФ)
      @b_skelton_useless = false                 # ȥؿ   (true λؿƽФ)
      @b_cell_unique = false                     # ͣθƤ襻
      @only_callee_port = nil                    # ͣθƤݡ
      @only_callee_cell = nil                    # ͣθƤ襻
    else
      # entry port optimize
      if $unopt then
        # Ŭʤ
        @b_VMT_useless = false                     # VMT  (true λ VMT 𤹤뤳ȤʤƽФ)
        @b_skelton_useless = false                 # ȥؿ   (true λؿƽФ)
      else
        # Ŭ
        @b_VMT_useless = true                      # VMT  (true λ VMT 𤹤뤳ȤʤƽФ)
        @b_skelton_useless = true                  # ȥؿ   (true λؿƽФ)
      end
    end
  end

  def set_celltype celltype
    @celltype = celltype
  end

  def get_name
    @name
  end

  def get_port_type
    @port_type
  end

  def ref_port port
    @ref_port_list << port
  end

  def get_signature
    @signature
  end

  def get_array_size
    @array_size
  end

  def get_celltype
    @celltype
  end

  #=== ݡȤ
  #port:: Port : send/receive ΤäƤӸޤϼ
  #fd:: Decl : ؿ declarator
  #par:: ParamDecl : send/receive Τä
  # θƤӸȤˤʤäƤӸޤϼξ
  def set_allocator_port( port, fd, par )
    @allocator_port = port
    @allocator_func_decl = fd
    @allocator_param_decl = par
  end

  def is_allocator_port?
    @allocator_port != nil
  end

  def get_allocator_port
    @allocator_port
  end

  def get_allocator_func_decl
    @allocator_func_decl
  end

  def get_allocator_param_decl
    @allocator_param_decl
  end

  def set_require( b_has_name )
    @b_require = true
    @b_has_name = b_has_name
  end

  def is_require?
    @b_require
  end

  #=== require ƤӸ̾ġ
  # require 
  def has_name?
    @b_has_name
  end

  def is_optional?
    @b_optional
  end

  def set_VMT_useless                     # VMT ؿơ֥Ѥʤ
   @b_VMT_useless = true
  end

  def set_skelton_useless                 # ȥؿ   (true λؿƽФ)
    @b_skelton_useless = true
  end

  def set_cell_unique                     # Ƥ襻ϰĤ
    @b_cell_unique = true
  end

  #=== ƤӸ/λҤ
  # inline, allocator λ
  def set_specifier spec_list
    spec_list.each { |s|
      case s[0]
      when :INLINE
        if @port_type == :CALL then
          Generator.error( "inline: cannot be specified for call port" )
        end
        @b_inline = true
      when :OPTIONAL
        if @port_type == :ENTRY then
          Generator.error( "optional: cannot be specified for entry port" )
        end
        @b_optional = true
      when :ALLOCATOR
        if @port_type == :CALL then
          Generator.error( "allocator: cannot be specified for call port" )
        end
        if @allocator_instance_tmp then
          Generator.error( "duplicate allocator specifier" )
        end
        @allocator_instance_tmp = s[1]
      else
        raise "unknown specifier #{s[0]}"
      end
    }
  end

  #=== 졼եΥ󥹥󥹤
  # ƤӸȲǽʤ褦ˡ륿פβκǸǹԤ
  def set_allocator_instance
    if @allocator_instance_tmp == nil then
      return
    end

    @allocator_instance = {}
    @allocator_instance_tmp.each { |ai|
      direction = nil
      alloc_type = ai[0]
      # ai = [ :SELF_ALLOC|:RELAY_ALLOC, func_name, param_name, rhs ]
      case alloc_type
      when :SELF_ALLOC
        Generator.error( "self allocator not supported yet" )
        next
      when :RELAY_ALLOC
        # OK
      else
        raise "unknown #{ai[0]}"
      end
      # '=' (func_name,param_name)ϼºߤ뤫?
      if @signature then       # signature = nil ʤ˥顼
        fh = @signature.get_function_head( ai[1] )
        if fh == nil then
          Generator.error( "function '#{ai[1]}' not found in signature" )
          next
        end
        decl = fh.get_declarator
        if ! decl.is_function? then
          next   # ˥顼
        end
        paramdecl = decl.get_type.get_paramlist.find( ai[2] )
        if paramdecl == nil then
          Generator.error( "'#{ai[2]}' not found in function '#{ai[1]}'" )
          next
        end
        case paramdecl.get_direction
        when :SEND, :RECEIVE
          # OK
          direction = paramdecl.get_direction
        else
          Generator.error( "'#{ai[2]}' in function '#{ai[1]}' is not send or receive" )
          next
        end
      end

      # ʣ꤬ʤ?
      if @allocator_instance[ "#{@name}_#{ai[1]}_#{ai[2]}" ] then
        Generator.error( "duplicate allocator specifier for '#{ai[1]}_#{ai[2]}'" )
      end

      # դΥå
      ele = ai[3].get_elements
      if ele[0] != :OP_DOT ||
          ele[1][0] != :OP_DOT || ele[1][1][0] != :IDENTIFIER || ! ele[1][2].instance_of?( Token ) ||
          ! ele[2].instance_of?( Token ) then
        Generator.error( "rhs not call_port.func.param for #{ai[1]}_#{ai[2]}" )
        next
      end
      func_name = ele[1][2]; cp_name = ele[1][1][1].to_s; param_name = ele[2].to_s
      cp = @celltype.find cp_name
      if cp then
        sig = cp.get_signature
        if sig then
          fh = @signature.get_function_head( func_name )
          if fh == nil then
            Generator.error( "function '#{func_name}' not found in signature '#{sig.get_name}'" )
            next
          end
          decl = fh.get_declarator
          if ! decl.is_function? then
            next   # ˥顼
          end
          paramdecl = decl.get_type.get_paramlist.find( param_name )
          if paramdecl == nil then
            Generator.error( "'#{param_name}' not found in function '#{func_name}'" )
            next
          end
          case paramdecl.get_direction
          when :SEND, :RECEIVE
            # OK
            if alloc_type == :RELAY_ALLOC && direction != paramdecl.get_direction then
              Generator.error( "relay allocator send/receive mismatch between #{ai[1]}.#{ai[2]} and #{cp_name}_#{func_name}.#{param_name}" )
            end
          else
            Generator.error( "'#{param_name}' in function '#{func_name}' is not send or receive" )
            next
          end

          # else
            # sig == nil ʤд˥顼
        end
      else
        Generator.error( "call port '#{cp_name}' not found in celltype #{@celltype.get_name}" )
        next
      end
      # եå
      # ai2 = [ :SELF_ALLOC|:RELAY_ALLOC, func_name, param_name, rhs_cp_name, rhs_func_name, rhs_param_name ]
      ai2 = [ ai[0], ai[1], ai[2], cp_name, func_name, param_name ]

      @allocator_instance[ "#{@name}_#{ai[1]}_#{ai[2]}" ] = ai2
    }
  end

  def is_inline?
    @b_inline
  end

  def is_VMT_useless?                     # VMT ؿơ֥Ѥʤ
   @b_VMT_useless
  end

  def is_skelton_useless?                 # ȥؿ   (true λؿƽФ)
    @b_skelton_useless
  end

  def is_cell_unique?                     # ƤΥϰġ
    @b_cell_unique
  end

  #=== Ŭ
  # μ򻲾ȤƤӸ VMT, skelton ɬפȤƤ뤫ɤ
  # ĤǤƤӸɬפȤƤʤʤ b_*_useless  false˾ϡ
  # μκŬ false Ȥ
  def set_entry_VMT_skelton_useless( b_VMT_useless, b_skelton_useless )
    if ! b_VMT_useless then
      @b_VMT_useless = false
    end
    if ! b_skelton_useless then
      @b_skelton_useless = false
    end
  end

  #=== ͣη
  # Ŭǻ
  #  b_VMT_useless == true || b_skelton_useless == true λꤵ
  #  optional ξ callee_cell, callee_port  nil Ȥʤ
  def set_only_callee( callee_port, callee_cell )
    @only_callee_port = callee_port
    @only_callee_cell = callee_cell
  end

  #=== ͣηݡȤ֤(compositeξ¥)
  # optional ƤӸ̤ξ nil ֤
  def get_real_callee_port
    if @only_callee_cell then
      return @only_callee_cell.get_real_port( @only_callee_port.get_name )
    end
  end

  #=== ͣη襻֤(compositeξ¥)
  # optional ƤӸ̤ξ nil ֤
  def get_real_callee_cell
    if @only_callee_cell then
      return @only_callee_cell.get_real_cell( @only_callee_port.get_name )
    end
  end

  def get_allocator_instance
    return @allocator_instance
  end

  #=== signature Τ٤ƤδؿΤ٤ƤΥѥ᡼򤿤ɤ
  #block:: ֥åȤƼ(ruby ʸˡǽ񤫤ʤ)
  #  ֥å3Ĥΰ(Port, Decl,      ParamDecl)    Decl: ؿإå
  # Signature 饹ˤ each_param ƱƯ
  def each_param # ֥å{  |port, func_decl, param_decl| }
    return if @signature == nil                         # signature ̤ʴ˥顼
    fha = @signature.get_function_head_array            # ƤӸޤϼΥ˥δؿ
    return if fha == nil                                # nil ʤʸˡ顼ͭͤꤵʤä

    pr = Proc.new   # Υ᥽åɤΥ֥å pr 
    port = self
    fha.each{ |fh|  # fh: FuncHead                      # ؿγƴؿƬ
      fd = fh.get_declarator                            # fd: Decl  (ؿƬDeclarotor)
      if fd.is_function? then                           # fd ؿǤʤСǤ˥顼
        fd.get_type.get_paramlist.get_items.each{ |par| # ٤ƤΥѥ᡼ˤĤ
          pr.call( port, fd, par )
        }
      end
    }
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Port: name: #{@name} port_type: #{@port_type} require: #{@b_require} inline: #{@b_inline} optional: #{@b_optional}"
    (indent+1).times { print "  " }
    if @signature then
      puts "signature: #{@signature.get_name}"
    else
      puts "signature: NOT defined"
    end
    if @array_size == "[]" then
      (indent+1).times { print "  " }
      puts "array_size: not specified"
    elsif @array_size then
      (indent+1).times { print "  " }
      puts "array_size: #{@array_size}"
    end
    if @allocator_instance then
      (indent+1).times { print "  " }
      puts "allocator instance:"
      @allocator_instance.each { |b,a|
        (indent+2).times { print "  " }
        puts "#{a[0]} #{b} "
        # a[3].show_tree( indent+3 )
      }
    end
    (indent+1).times { print "  " }
    if @port_type == :CALL then
      puts "VMT_useless : #{@b_VMT_useless}  skelton_useless : #{@b_skelton_useless}  cell_unique : #{@b_cell_unique}"
    else
      puts "VMT_useless : #{@b_VMT_useless}  skelton_useless : #{@b_skelton_useless}"
    end
  end

end

class Namespace
# @name::  str
# @path:: name ѥ
# @global_name:: str
# @name_list:: NamedList   Signature,Celltype,CompositeCelltype,Cell,Typedef,Namespace
# @struct_tag_list:: NamedList : StructType
# @namespace_list:: Namespace[]
# @signature_list:: Sginature[]
# @celltype_list:: Celltype[]
# @compositecelltype_list:: CompositeCelltype[]
# @cell_list:: Cell[]
# @typedef_list:: Typedef[]
# @decl_list:: ( Typedef | StructType | EnumType )[]   ¸طơ֤ɤ˳Ǽ mikan enum
# @const_decl_list:: Decl[]
# @region_list:: Region[]

  # mikan namespace  push, pop

  @@namespace_stack = []      # @@namespace_stack[0] = "::" (generator.rb)
  @@namespace_sp = -1

  def initialize( name )
    @path = Namespace.get_path
    @name = name

    if @@namespace_sp >= 0 then   # root Ͻ
      @@namespace_stack[@@namespace_sp].new_namespace( self )
    end
    @@namespace_sp += 1
    @@namespace_stack[ @@namespace_sp ] = self

    @global_name = Namespace.get_global_name    # stack Ͽ
    @name_list = NamedList.new( nil, "symbol in namespace '#@name'" )
    @struct_tag_list = NamedList.new( nil, "struct tag" )

    @namespace_list = []
    @signature_list = []
    @celltype_list = []
    @compositecelltype_list = []
    @cell_list = []
    @typedef_list = []
    @decl_list = []
    @const_decl_list = []

  end

  def end_of_parse
    @@namespace_sp -= 1
    if @@namespace_sp < 0 then
      raise "StackUnderflow"
    end

  end

  def get_name
    @name
  end

  def self.get_path
    if @@namespace_sp == -1 then
      return ""
    elsif @@namespace_sp == 0 then
      return "::"
    end

    i = 1
    path = ""
    while i <= @@namespace_sp
      path = path+"::"+@@namespace_stack[i]
      i += 1
    end

    path
  end

  def self.get_global_name    # parse ͭ
    if @@namespace_sp <= 0 then
      return ""
    end

    path = @@namespace_stack[1].get_name
    i = 2
    while i <= @@namespace_sp
      path = path+"_"+@@namespace_stack[i].get_name
      i += 1
    end

    path
  end

  # path [ "::", "ns1", "ns2" ]   absolute
  # path [ "ns1", "ns2" ]         relative

  def self.find( path )

    length = path.length
    return self.find_one( path[0] ) if length == 1

    name = path[0]
    if name == "::" then
      i = 1
      name = path[i]   # ʸŪɬ¸
      object = @@namespace_stack[0].find( name )  # root
    else
      i = 0
      object = @@namespace_stack[@@namespace_sp].find( name ) # crrent
    end

    i += 1
    while i < length

      unless object.instance_of?( Namespace ) then
#        if path[i] != nil then		## mikan ɬס
          Generator.error( "'#{name}' not namespace" )
          return nil
#        end
#        return object
      end

      object = object.find( path[i] )
      i += 1
    end

    return object
  end


  def find( name )
    @name_list.get_item(name)
  end

  #===  namespace õĤʤп namespace õ
  def self.find_one( name )

    i = @@namespace_sp
    while i >= 0
      object = @@namespace_stack[i].find( name )
      return object if object != nil
      i -= 1
    end
    return nil

  end

  def self.get_current
    @@namespace_stack[@@namespace_sp]
  end

  def self.find_tag( name )   # mikan tag : namespace  path бʤ
    @@namespace_stack[@@namespace_sp].find_tag( name )
  end

  def find_tag( name )
    @struct_tag_list.get_item( name )
  end

 ### namespace
  def self.new_namespace( namespace )
    @@namespace_stack[@@namespace_sp].new_namespace( namespace )
  end

  def new_namespace( namespace )
    @name_list.add_item( namespace )
    @namespace_list << namespace
  end

 ### signature
  def self.new_signature( signature )
    @@namespace_stack[@@namespace_sp].new_signature( signature )
  end

  def new_signature( signature )
    @name_list.add_item( signature )
    @signature_list << signature
  end

 ### celltype
  def self.new_celltype( celltype )
    @@namespace_stack[@@namespace_sp].new_celltype( celltype )
  end

  def new_celltype( celltype )
    @name_list.add_item( celltype )
    @celltype_list << celltype
  end

 ### compositecelltype
  def self.new_compositecelltype( compositecelltype )
    @@namespace_stack[@@namespace_sp].new_compositecelltype( compositecelltype )
  end

  def new_compositecelltype( compositecelltype )
    @name_list.add_item( compositecelltype )
    @compositecelltype_list << compositecelltype
  end

 ### cell (Namespace)
  def self.new_cell( cell )
    @@namespace_stack[@@namespace_sp].new_cell( cell )
  end

  def new_cell( cell )
    @name_list.add_item( cell )
    @cell_list << cell
  end

  def check_ref_but_undef
    @cell_list.each { |c|
      if ! c.get_f_def then   # Namespace  @cell_list ˤϥץȥפޤޤ륱
        if c.get_f_ref then
          Generator.error( "#{c.get_global_name} : undefined cell" )
        elsif $verbose then
          Generator.warning( "#{c.get_global_name} : only prototype, unused and undefined cell" )
        end
      else
        ct = c.get_celltype
        if c.get_f_ref == false && ct && ct.is_inactive? then
          Generator.warning( "#{c.get_global_name} : non-active cell has no entry join and no factory" )
        end
      end
    }
    @namespace_list.each { |n|
      n.check_ref_but_undef
    }
  end

 ### struct
  def self.new_structtype( struct )
    @@namespace_stack[@@namespace_sp].new_structtype( struct )
  end

  def new_structtype( struct )
    @struct_tag_list.add_item( struct )
    @decl_list << struct
  end

 ### typedef
  def self.new_typedef( typedef )
    @@namespace_stack[@@namespace_sp].new_typedef( typedef )
  end

  def new_typedef( typedef )
    @name_list.add_item( typedef )
    @typedef_list << typedef
    @decl_list << typedef
  end

  def self.is_typename?( str )
    i = @@namespace_sp
    while i >= 0
      if @@namespace_stack[i].is_typename?( str ) then
        return true
      end
      i -= 1
    end
    false
  end

  def is_typename?( str )
    if @name_list.get_item( str ).instance_of?( Typedef ) then
      true
    else
      false
    end
  end

 ### const_decl
  def self.new_const_decl( decl )
    @@namespace_stack[@@namespace_sp].new_const_decl( decl )
  end

  def new_const_decl( decl )
    if ! decl.is_const? then			# const Ƥ뤳
      if decl.is_type?( PtrType )
        Generator.error( "#{decl.get_name}: pointer is not constant. check 'const'" )
      else
        Generator.error( "#{decl.get_name}: not constant" )
      end
    elsif ! decl.is_type?( IntType ) && ! decl.is_type?( FloatType ) &&
        ! decl.is_type?( BoolType ) && ! decl.is_type?( PtrType ) then
                                            # IntType, FloatType Ǥ뤳
      Generator.error( "#{decl.get_name}: should be int, float, bool or pointer type" )
    elsif decl.get_initializer == nil then   # ͤĤ
      Generator.error( "#{decl.get_name}: has no initializer" )
#    elsif decl.get_initializer.eval_const(nil) == nil then  #eval_const  check_init ǸƽФΤťå
#                                            # mikan ͤФŬڤǤ뤳
#      Generator.error( "#{decl.get_name}: has unsuitable initializer" )
    else
      decl.get_type.check_init( decl.get_name, decl.get_initializer, :CONSTANT )
      @name_list.add_item( decl )
      @const_decl_list << decl
    end

  end

 ### region
  def self.new_region( region )
    @@namespace_stack[@@namespace_sp].new_region( region )
  end

  def new_region( region )
    @name_list.add_item( region )
  end

 ###

  #=== ٤ƤΥ require ݡȤ
  def set_require_join
    @celltype_list.each{ |ct|
      ct.set_require_join
    }
    # ٤Ƥ namespace ˤĤ require ݡȤ򥻥å
    @namespace_list.each{ |ns|
      ns.set_require_join
    }
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Namespace: name: #{@name} path: #{@path}"
    @struct_tag_list.show_tree( indent + 1 )
    @name_list.show_tree( indent + 1 )
  end

end


class Join
# @name:: string
# @subscript:: nil: not array, -1: subscript not specified, >=0: array_subscript
# @rhs:: Expression | initializer ( array of Expression | initializer (Expression | C_EXP) )
# @definition:: Port, Decl(attribute or var)
# @namespace:: Namespace
#
# available if definition is Port
# @cell_name:: string : դΥ̾
# @cell:: Cell  : դΥ
# @celltype:: Celltype : դΥ륿
# @port_name:: string : դμ̾
# @port:: Port : դμ
# @array_member:: rhs array : available only for first appear in the same name
# @array_member2:: Join array : available only for first appear in the same name
#

# @through_list::  @cp_through_list + @region_through_list
#  ʲι¤ġ@cp_through_list ι¤϶̡
# @cp_through_list::  ƤӸ˻ꤵ줿 through
#   [ [plugin_name, cell_name, plugin_arg], [plugin_name2, cell_name2, plugin_arg], ... ]
# @region_through_list::  region ˻ꤵ줿 through
#   [ [plugin_name, cell_name, plugin_arg, region], [plugin_name2, cell_name2, plugin_arg, region2], ... ]
#
# @through_generated_list:: [Plugin_class object, ...]: @through_list б
# @region_through_generated_list:: [Plugin_class object, ...]: @region_through_list б
#
# @@loaded_plugin_list:: {string=>bool}
# @@newed_plugin_cell_count:: = {int}

  @@loaded_plugin_list = {}
  @@newed_plugin_cell_count = {}

  #=== Join ν
  #name:: string: ̾°̾ƤӸ̾
  #subscript:: Nil=, -1="[]", N="[N]"
  #rhs:: Expression: դμ
  def initialize( name, subscript, rhs )
    @name = name
    @namespace = Namespace.get_current
    if subscript.instance_of?( Expression ) then
       #mikan źǤ뤳Ȥ̤å
       @subscript = subscript.eval_const(nil)
       if @subscript == nil then
         Generator.error( "array subscript not constant" )
       end
    else
       @subscript = subscript
    end

    @rhs = rhs

    # Ǥ
    # ϡФǤΤꤹΤŬ
    # new_join  add_array_member ǽǤ array_member Фꤹ
    if @subscript == -1 then
      @array_member  = [self]
      @array_member2 = [self]
    elsif @subscript != nil then
      @array_member = []
      @array_member2 = []
      @array_member[@subscript]  = self
      @array_member2[@subscript] = self
    end
  end

  #===  Join դб celltype ꤹȤȤ˥å
  # STAGE:   S
  #
  #     ǽå
  #definition:: Decl (attribute,varλ) ޤ Port (callλ) ޤ nil (definition Ĥʤä)

  def set_definition( definition )

    @definition = definition

    # mikan ͤ͡ηåʤ
    if @definition.instance_of?( Decl ) then

      # attribute, var ξ
      if @definition.get_kind == :ATTRIBUTE then
#        check_cell_cb_init( definition.get_type, @rhs )
         # դǽǽå
         definition.get_type.check_init( definition.get_identifier, @rhs, :ATTRIBUTE )
      elsif @definition.get_kind == :VAR then
        # var ϽǤʤ
        Generator.error( "#{@name}: cannot initialize var" )
      else
        # Bug trap
        raise "UnknownDeclKind"
      end
    elsif @definition.instance_of?( Port ) then
      ### Port

      # դϼʼ褦ȤƤˡ
      if @definition.get_port_type == :ENTRY then
         Generator.error( "'#{@name}' cannot initialize entry port" );
         return
      end

#      # źå
#      # ƤӸǡʤźʤźʤʤźʤźʤź
      as = @definition.get_array_size
      if ( @subscript == nil && as != nil ) then
        Generator.error( "#{@name}: must specify array subscript here" )
      elsif ( @subscript != nil && as == nil ) then
        Generator.error( "#{@name}: cannot specify array subscript here" )
      end
#      if @subscript == nil then
#        if as != nil then
#          Generator.error( "#{@name}: need array subscript" )
#        end
#      elsif @subscript == -1 then
#        if as != "[]" then
#          Generator.error( "#{@name}: need array subscript number. ex. '[0]'" )
#        end
#      else # @subscript >0
#        if as == nil then
#          Generator.error( "#{@name}: cannot specify array subscript here" )
#        elsif as == "[]" then
#          Generator.error( "#{@name}: cannot specify array subscript number. use '[]'" )
#        end
#      end

      @through_list = []
      @cp_through_list = []
      @region_through_list = []
      @through_generated_list = []
      @region_through_generated_list = []

      # mikan Expression  get_type ǷƳФޡ
      # mikan '=' κդ󤫤ɤ̤å
      #(1) '=' αդ "Cell.ePort" η
      #     黻Ҥ "."   "." κդ :IDENTIFIER
      #     "." αդϥå (synatax Ū :IDENTIFIER)
      #(2) "Cell" ¸ߤ뤫̾פΤϤ뤫
      #(3) "Cell"  cell 
      #(4) "Cell"  celltype ͭ (̵ʤ˥顼
      #(5) "ePort"  "Cell"  celltype ¸ߤ뤫
      #(6) "ePort"  entry port 
      #(7) signature ϰפ뤫

      # դʤʰʳǥ顼
      return unless @rhs

      # cCall = composite.cCall; Υåη°
      # ƤӸ export ˤ cCall => composite.cCall; ηѤ
      if @rhs.instance_of?( Array ) == true && @rhs[0] == :COMPOSITE then
        Generator.error "to export port, use 'cCall => composite.cCall'"
        return
      elsif ! @rhs.instance_of?( Expression ) then
        raise "Unknown bug. specify -t to find problem in source"
      end

      # դ Expression ǤФ
      elements = @rhs.get_elements
      if elements[0] == :OP_SUBSC then  # ա
        subscript = elements[2].eval_const(nil)  # ź
        elements  = elements[1]          # mikan ä
        array     = true
      else
        array = false
      end

      if elements[0] != :OP_DOT || elements[1][0] != :IDENTIFIER then   #(1)
        Generator.error( "#{@name}: rhs not 'Cell.ePort' form" )
        return
      end

      @cell_name = elements[1][1].val
      @port_name = elements[2].val

      # composite ʤ object Ϸ cell Ĥʤ nil ֤
      # composite ʤ false ֤
      object = CompositeCelltype.find( @cell_name )
      if object == false then
#       mikan դ namespace бƤʤᡣ path ˤ find
#       object = Namespace.find( @cell_name )
        object = Namespace.find( [ @cell_name ] )
        in_composite = false
      else
        in_composite = true
      end

      if object == nil then                                             # (2)
        Generator.error( "'#{@cell_name}' not found" )
      elsif ! object.instance_of?( Cell ) then                          # (3)
        Generator.error( "'#{@cell_name}' not cell" )
      else
        # դΥ򻲾ȺѤߤˤ
        object.set_f_ref

        # դΥΥ륿
        celltype = object.get_celltype

        if celltype then                                                # (4)
          object2 = celltype.find( @port_name )
          if object2 == nil then                                        # (5)
            Generator.error( "'#{@port_name}' not found" )
          elsif ! object2.instance_of? Port \
               || object2.get_port_type != :ENTRY then                  # (6)
            Generator.error( "'#{@port_name}' not entry port" )
          elsif @definition.get_signature != object2.get_signature then # (7)
            Generator.error( "'#{@port_name}' signature mismatch" )
          elsif object2.get_array_size then
            # 

            unless array then
              # դź꤬ʤä
              Generator.error( "'#{@port_name}' should be array" )
            else

              as = object2.get_array_size
              if( as.kind_of?( Integer ) && as <= subscript )then
# p "Cell: region: #{@region.get_name} name: #{name}"
                 # 礭ФդźƱ礭
                 Generator.error( "#{@port_name}[#{subscript}]: subscript out of range (< #{as})" )
              else
#                puts "Join OK!"
                @cell = object
                @celltype = celltype
                # object2: Port, @definition: Port
                object2.ref_port @definition
                @port = object2
                @cell.set_entry_port_max_subscript( @port, subscript )
              end

               # debug
               # print "Join set_definition: rhs: #{@cell}  #{@cell.get_name}\n"

            end
          elsif array then
              # ǤʤΤ˱դźꤵƤ
              Generator.error( "'#{@port_name}' entry port is not array" )
          else
#            puts "Join OK!"

            @cell = object
            @celltype = celltype

            # object2: Port, @definition: Port
            object2.ref_port @definition
            @port = object2

            # debug
            # p "rhs:  #{@cell}  #{@cell.get_name}"
          end  # end of port (object2) å

        #else
        #  celltype == nil (Ǥ˥顼)
        end  # end of celltyep å

        create_allocator_join( object )
        check_region( object )

      end  # end of cell (object) å

    elsif @definition == nil then
      Generator.error( "'#@name' not in celltype" )

    else
      raise "UnknownToken"
    end
  end

  #=== η
  #cell::  ƤӸηΥ
  #
  # ǤϸƤӸ¦륢ƤӸη
  # ¦ Cell  set_specifier_list 
  #  a[*] Ƥ Cell  set_specifier_list 򻲾
  def create_allocator_join( cell )
    if( cell.get_allocator_list ) then
      cell.get_allocator_list.each { |a|

        # դź
        elements = @rhs.get_elements
        if elements[0] == :OP_SUBSC then
          subscript = elements[2].eval_const(nil) # ź:OP_SUBSC 
        else
          subscript = nil
        end

        if( a[0] == @port_name && a[1] == subscript )then
          # ̾ΰפΤη
          # ­ϡӥå
          cp_name = "#{@name}_#{a[2]}_#{a[3]}"
          # p "creating allocator join #{cp_name} #{@subscript} #{a[1]}"
          join = Join.new( cp_name, @subscript, a[4] )
          Cell.new_join join
        end
      }
    end
  end

  @@in_through_count = 0
  @@out_through_count = 0
  @@to_through_count = 0

  #=== ꡼֤ηå
  # ꡼֤ through ˤ @region_through_list κ
  # ºݤ check_and_gen_through ǹԤ
  def check_region( object )

    # ץ饰줿ʤǤʤ
    # ʤȥץ饰줿ΤȤδ֤ǡ̵¤
#    if Generator.get_nest >= 1 then
    if Generator.get_plugin then
# p "check_region #{@name} not"
      return
    end

# p "check_region #{@name}"

    # region Υå
    r1 = Region.get_current     # ƤӸ region
    r2 = object.get_region      #  region

    if ! r1.equal? r2 then      # Ʊ region ʤƽФǽ

      # mikan namespace б
      f1 = r1.get_family_line
      len1 = f1.length
      f2 = r2.get_family_line
      len2 = f2.length

      # ԰פˤʤȤʷˤõ
      i = 1  # i = 0  :RootRegion ʤΤɬ
      while( i < len1 && i < len2 )
        if( f1[i] != f2[i] )then
          break
        end
        i += 1
      end

      sibling_level = i     # Ȥʤ٥롢⤷Ϥɤ餫ä٥

      # p "silibing_level: #{i}"
      # p "from: #{f1[i].get_name}" if f1[i]
      # p "to: #{f2[i].get_name}" if f2[i]

      # Ƥ¦ˤĤƸƤӸΥ٥뤫鷻٥ޤǡout_through å
      i = len1 -1
      while i >= sibling_level
        # print "going out from #{f1[i].get_name} level=#{i}\n"
        out_through_list = f1[i].get_out_through_list   # [ plugin_name, plugin_arg ]
        if out_through_list.length == 0 then
          Generator.error( "#{@name}: going out from region '#{f1[i].get_name}' not permitted" )
        end

        out_through_list.each { |ol|
          if ol[0] then    # plugin_nmae ꤵƤʤϿʤ
            plugin_arg = ol[1].gsub( /^"(.*)"$/, '\1' )    #  "" 
            through = [ ol[0], "Join_out_through__#{@@out_through_count}", plugin_arg, f1[i] ]
            @region_through_list << through
            @@out_through_count += 1
          end
        }
        i -= 1
      end

      # ٥ˤơto_through å
      if f1[sibling_level] && f2[sibling_level] then
        # print "going from #{f1[sibling_level].get_name} to #{f2[sibling_level].get_name}\n"
        found = 0
        f1[sibling_level].get_to_through_list.each { |t|
          if t[0][0] == f2[sibling_level].get_name then   # region ̾פ뤫 ?
          # mikan namespace бƤʤ (RootNamespace ˤʤưʤ)
            if t[1] then    # plugin_nmae ꤵƤʤϿʤ
              plugin_arg = t[2].gsub( /^"(.*)"$/, '\1' )    #  "" 
              through = [ t[1], "Join_to_through__#{@@to_through_count}", plugin_arg, f1[sibling_level] ]
              @region_through_list << through
              @@to_through_count += 1
            end
            found = 1
          end
          if found == 0 then
            Generator.error( "#{@name}: going from region '#{f1[sibling_level].get_name}' to #{f2[sibling_level].get_name}' not permitted" )
          end
        }
      end

      # ¦ˤĤƷ٥뤫¦Υ٥ޤǡin_through å
      i = sibling_level
      while i < len2
        # print "going in to #{f2[i].get_name} level=#{i}\n"
        in_through_list = f2[i].get_in_through_list   # [ plugin_name, plugin_arg ]
        if in_through_list.length == 0 then
          Generator.error( "#{@name}: going in to region '#{f2[i].get_name}' not permitted" )
        end
        in_through_list.each { |il|
          if il[0] then    # plugin_nmae ꤵƤʤϿʤ
            plugin_arg = il[1].gsub( /^"(.*)"$/, '\1' )    #  "" 
            through = [ il[0], "Join_in_through__#{@@in_through_count}", plugin_arg, f2[i] ]
            @region_through_list << through
            @@in_through_count += 1
          end
        }
        i += 1
      end

    end
  end

  #=== ʤ꡼ؤη礫å
  # դΥ뤬ʤ꡼ˤХ顼
  # դϡץ饰줿뤬СоݤȤ
  def check_region2

    # ʤ꡼Υؤη礫
    # if join.get_cell && ! join.get_cell.is_generate? then
    # if get_rhs_cell && ! get_rhs_cell.is_generate? then # composite 뤬ץξ㳰
    if get_rhs_region && get_rhs_region.is_generate? != true then
      Generator.error( "'#{get_cell.get_name}' in region '#{get_cell.get_region.get_path_string}' cannot be directly joined" )
    end
  end

  def get_definition
    @definition
  end

  #=== Join  specifier 
  # STAGE: B
  # set_specifier_list ϡjoin βϤκǸǸƤӽФ
  # through Ҥ
  #  check_and_gen_through ƽФơthrough 
  def set_specifier_list( specifier_list )

    specifier_list.each { |s|
      case s[0]
      when :THROUGH
        if ! @definition.instance_of? Port then
          Generator.error( "#{@name} : not port: 'through' can be specified only for port" )
        else

          # set plugin_name
          plugin_name = s[1].to_s
          plugin_name[0] = "#{plugin_name[/^./].upcase}"     # Ƭʸʸ : ruby Υ饹̾

          # set cell_name
          count = @@newed_plugin_cell_count[ plugin_name ]
          count = 0 if count == nil
          @@newed_plugin_cell_count[ plugin_name ] = count + 1
          cell_name = "#{s[1].to_s}_#{count}"

          # set plugin_arg
          plugin_arg = s[2].to_s.gsub( /^"(.*)"$/, '\1' )   #  "" 

          @cp_through_list << [ plugin_name, cell_name, plugin_arg ]

        end
      end
    }

    if @definition.instance_of?( Port ) && @definition.get_port_type == :CALL then
      check_and_gen_through
    end
  end

  #=== through Υå
  # new_join  check_region  region ֤ through  @region_through ꤵ
  # set_specifier ǸƤӸηǻꤵ줿 through  @cp_through ꤵ
  # θ塢Υ᥽åɤƤФ
  def check_and_gen_through

    @through_list = @cp_through_list + @region_through_list
      # 夫 @cp_through_list  @region_through_list ʬᡢΤ褦ʼˤʤä

    if @through_list then           # nil when the join is not Port
      len = @through_list.length    # through ϢܤƤ
    else
      len = 0
    end
    cp_len = @cp_through_list.length

    # Ϣ³ through ˤĤơ¦˥᤹
    i = len - 1
    while i >= 0

      through = @through_list[ i ]
      plugin_name           = through[ 0 ]
      generating_cell_name  = through[ 1 ]
      plugin_arg            = through[ 2 ]

      if i != len - 1 then

        begin
          next_cell_name      = @through_generated_list[ i + 1 ].get_cell_name
          next_port_name      = @through_generated_list[ i + 1 ].get_through_entry_port_name
        rescue Exception => evar
          if $debug then
            p evar
          end

          Generator.error( "#{plugin_name}: plugin function failed: 'get_through_entry_port_name'" )
          i -= 1
          next
        end

      else
        # ǸΥξ硢Υ̾ݡ̾
        next_cell_name      = @cell_name
        next_port_name      = @port_name
      end

      if i >= cp_len then
        # region_through_list ʬ
        # region  @cell_name.@port_name ؤ through ʤõ
        rp = @through_list[i][3].find_cell_port_through_plugin( @cell_name, @port_name )
           # @through_list[i]  @region_through_list[i-cp_len] Ʊ
        # Ѥʤ褦ˤˤϡĤʤäȤˤФ褤
        # rp = nil
      else
        # region ʳΤΤ϶ͭʤ
        # ƤӸ¦˻ꤵƤ뤷plugin_arg ۤʤ뤫⤷ʤ
        rp = nil
      end

      if rp == nil then
        load_plugin( plugin_name )
        gen_through_cell_code_and_parse( plugin_name, i, next_cell_name, next_port_name )
      else
        # ĤäΤѤ
        @through_generated_list[ i ] = rp
      end

      if i >= cp_len then
        # @through_generated_list Τ @region_through_listбʬ
        @region_through_generated_list[ i - cp_len ] = @through_generated_list[ i ]
        if rp == nil then
          # Τ region(@through_list[i][3]) ΥꥹȤɲ
          @through_list[i][3].add_cell_port_through_plugin( @cell_name, @port_name, @through_generated_list[i] )
        end
      end

      if i == 0 then
        # ǤƤӸ¦ΥϡCDL η礬ʤᡢȤ줿Ȥˤʤʤ
        # mikan namespace б
        cell = Namespace.find( [ @through_generated_list[0].get_cell_name] )
        if cell.instance_of? Cell then
          cell.set_f_ref
        end
      end

      i -= 1
    end

  end

  #=== ץ饰ɤ
  # Ǥ˥ɤƤΤϡʣƥɤʤ
  def load_plugin( plugin_name )

    unless @@loaded_plugin_list[ "#{plugin_name}.rb" ] then
      @@loaded_plugin_list[ "#{plugin_name}.rb" ] = true
      if ( $verbose ) then
        print( "load '#{plugin_name}.rb'\n" )
      end
      # "#{plugin_name}.rb" ɡʥƥѤǤϤʤΤǡfatal 顼ˤʤ
      if require_tecsgen_lib( "#{plugin_name}.rb", false ) == false
        Generator.error( "#{plugin_name}.rb : fail to load plugin" )
      end
    end
  end

  def gen_through_cell_code_and_parse( plugin_name, i, next_cell_name, next_port_name )

    through = @through_list[ i ]
    plugin_name           = through[ 0 ]
    generating_cell_name  = through[ 1 ]
    plugin_arg            = through[ 2 ]

    begin
      plugin_object = nil
      eval_str = "plugin_object = #{plugin_name}.new( '#{generating_cell_name}', '#{plugin_arg}', '#{next_cell_name}', '#{next_port_name}', @definition.get_signature, @celltype )"
      if $verbose then
        print "new through: #{eval_str}\n"
      end

      eval ( eval_str )     # plugin 
      @through_generated_list[ i ] = plugin_object

      tmp_file_name = "#{$gen}/tmp_#{plugin_name}_#{generating_cell_name}_#{@@newed_plugin_cell_count[ plugin_name ]}.cdl"

      begin
        tmp_file = CFile.open( tmp_file_name, "w" )
        begin
          @through_generated_list[ i ].gen_through_cell_code( tmp_file )
        rescue Exception => evar
          if $debug then
            print "stack trace\n"
            p $@
            p evar
          end

          Generator.error( "#{plugin_name}: plugin error in gen_through_cell_code " )
        end
        begin
          tmp_file.close
        rescue
          Generator.error( "#{plugin_name}: close error '#{tmp_file_name}'" )
        end
      rescue
        Generator.error( "#{plugin_name}: open error '#{tmp_file_name}'" )
      end

      generator = Generator.new
      generator.set_plugin( plugin_object )
      generator.parse( [ tmp_file_name ] )
      generator.finalize

    rescue Exception => evar
      Generator.error( "#{plugin_name}: fail to new" )

      print "eval( #{eval_str} )\n"
      print "#{evar}\n"
      if $debug then
        print "stack trace\n"
        p $@
      end
    end
  end

  def get_name
    @name
  end

  def get_subscript
    @subscript
  end

  def get_cell_name         # ̾
    @cell_name
  end

  def get_celltype
    @celltype
  end

  def get_cell
    @cell
  end

  #=== դμ¥
  #    ¥Ȥ through 줿Ρcomposite ʤɼºݤ˷礵
  #    Υ᥽åɤϡget_rhs_port ФˤʤäƤ
  def get_rhs_cell
    # through ꤢꡩ
    if @through_list[0] then
      # mikan through Τ root namespace 
      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )
      return cell.get_real_cell( @through_generated_list[0].get_through_entry_port_name )
    elsif @cell then
      return @cell.get_real_cell( @port_name )
    else
      # դ̤ξ @cell  nil (˥顼)
      return nil
    end
  end

  #=== դΥΥ꡼
  # դ̤ξ硢nil ֤
  # composite ξ硢¥ǤϤʤ composite cell  region ֤(composite Ϥ٤Ʊ region °)
  # composite  cell ץȥƤȤ get_rhs_cell/get_real_cell  ruby 㳰Ȥʤ
  def get_rhs_region
    # through ꤢꡩ
    if @through_generated_list[0] then
      # mikan through Τ root namespace 
      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )
      if cell then
        return cell.get_region
      end
    elsif @cell then
      return @cell.get_region
    end
    # դ̤ξ @cell  nil (˥顼)
    return nil
  end


  def get_cell_global_name  # ̾ʥݥåȤʤŸ¦Υ

    # debug
    # print "cell get_cell_global_name:  #{@cell_name}\n"
    # @cell.show_tree( 1 )

    # cell = @namespace.find( @cell_name )
    if @cell then
      return @cell.get_real_global_name( @port_name )
    else
      return "NonDefinedCell?"
    end

  end

  #===  αդμ̾
  #     namespace ̾ + '_' + ̾ + '_' + ̾   ʤΥ뤬 composite ʤŸΥ̾̾
  #subscript:: Integer  ƤӸλź ޤ nil ƤӸǤʤ
  def get_port_global_name( subscript = nil )  # ̾ʥݥåȤʤŸ¦Υ

    # debug
    # print "Cell get_port_global_name:  #{@cell_name}\n"

    # cell = @namespace.find( @cell_name )

    # through ꤢꡩ
    if @through_list[0] then

      # mikan through Τ root namespace 
      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )

      # through 줿ǡºݤ³륻compositeξ)μ C ̾
      return cell.get_real_global_port_name( @through_generated_list[0].get_through_entry_port_name )
    else

      # ºݤ³륻μ C ̾
      if @cell then
        return @cell.get_real_global_port_name( @port_name )
      else
        return "UndefinedCellsPort?"
      end

    end

  end

  def get_port_name
    @port_name
  end

  def get_rhs
    @rhs
  end

  #=== դΥݡȤ
  #    դ composite ξϡηҤ륻Υݡ, through ξ줿Υݡ
  #    Υ᥽åɤ get_rhs_cell ФˤʤäƤ
  def get_rhs_port
    # through ꤢꡩ
    if @through_list[0] then
      # mikan through Τ root namespace 
      # through 줿õ
      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )
      # cell Υץ饰줿ݡ̾ΥݡȤõ (composite ʤηҤݡ)
      return cell.get_real_port( @through_generated_list[0].get_through_entry_port_name )
    else
      # ݡȤ֤(composite ʤηҤݡȤ֤)
      return @cell.get_real_port( @port_name )
    end
  end


  #=== ƤӸ2ܰʹߤǤɲä
  #     ֺǽ줿ǤǤνͤ
  #     Υ᥽åɤξƽФjoin ʣ顼ξ
  #join2:: Join  ƤӸǤ Join
  def add_array_member join2

    # subscript2: join2 κź
    subscript2 = join2.get_subscript

    if @subscript == nil then		# not array : initialize duplicate
      # ξ硢join ʣƤ
      Generator.error( "'#@name' duplicate" )

    elsif @subscript >= 0 then
      # źꤢξ
      if( subscript2 == nil || subscript2 < 0 ) then
        # join2 դޤźʤ
        # ԰
        Generator.error( "'#@name' inconsistent array definition" )
      elsif @array_member[subscript2] != nil then
        # ƱźѤ
        Generator.error( "'#@name' redefinition of subscript #{subscript2}" )
      else
        # źΰ֤Ǥɲ
        @array_member[subscript2] = join2.get_rhs
        @array_member2[subscript2] = join2
#        p "0:#{join2.get_rhs}"
      end

    else
      # źʤξ
      if( subscript2 == nil || subscript2 >= 0 ) then
        # join2 դޤźͭ
        # ԰
        Generator.error( "'#@name' inconsistent array definition" )
      end

      # źʤξ硢Ǥɲ
      @array_member  << join2.get_rhs
      @array_member2 << join2
    end
  end

  def get_array_member
    @array_member
  end

  def get_array_member2
    @array_member2
  end

  def change_name name
    # debug
    # print "change_name: #{@name} to #{name}\n"

    @name = name

    if @array_member2 then
      i = 0
      while i < @array_member2.length
        if @array_member2[i] != self && @array_member[i] != nil then
          # @array_member2[i]  nil ˤʤΤ optional λȡ
          # Join  initialize ̵̤ @array_member2 ꤵƤ
          # ̵̤ꤵƤΤˤĤƤϡƵŪ˸ƤӽФɬפϤʤclone_for_composite ǤкƤ
          @array_member2[i].change_name( name )
        end
        i += 1
      end
    end
  end

  # composite cell Ÿη clone ̾ѹ
  def change_rhs_port( clone_cell_list, celltype )

    # debug
    # print "change_rhs name: #{@name}  cell_name: #{@cell_name} #{@cell}\n"

    # debug
    # clone_cell_list.each{ |cell, ce|
    #   print "change_rhs:  #{cell.get_name}=#{cell} : #{ce.get_name}\n"
    # }

    c = clone_cell_list[@cell]
    return if c == nil

    # debug
    # print "  cell_name:   #{@cell_name} => #{c.get_global_name}\n"

    @cell_name = c.get_name
    @cell = c

    if @array_member2 then

      # debug
      # p "array_member2.len : #{@array_member.length}"

      i = 0
      while i < @array_member2.length
        # @array_member2[i]  nil ˤʤΤ optional λȡ
        # Join  initialize ̵̤ @array_member2 ꤵƤ
        # ̵̤ꤵƤΤˤĤƤϡƵŪ˸ƤӽФɬפϤʤclone_for_composite ǤкƤ
        if @array_member2[i] != self && @array_member[i] != nil then
          @array_member2[i].change_rhs_port( clone_cell_list, celltype )
        end
        i += 1
      end
    end

  end

  #=== Join  composite Ѥ˥
  #cell_global_name:: string : ƥΥХ̾
  # դ C_EXP ˴ޤޤ $id$, $cell$, $ct$ ִ
  # ִΤ composite  attribute  C_EXP  composite 륿פӥִ̾뤿
  #  C_EXP ⤳ִ
  def clone_for_composite( ct_name, cell_name, b_need_recursive = true )

    # debug
    # print "join.clone_for_composite : #{@name} #{@cell_name} #{self}\n"
    cl = self.clone

    if @array_member2 && b_need_recursive then
      cl.clone_array_member( @array_member, @array_member2, ct_name, cell_name, self )
    end

    # Join  attribute Ǳդ C_EXP ξ
    if @rhs.instance_of? C_EXP then
      # C_EXP  clone ȤȤִ
      rhs = @rhs.clone_for_composite( ct_name, cell_name )
      cl.change_rhs rhs
    end

    # debug
    # print "join cloned : #{cl}\n"
    return cl
  end

  def clone_array_member( array_member, array_member2, ct_name, cell_name, prev )
    am  = array_member.clone
    am2 = array_member2.clone

    i = 0
    while i < am2.length
      if array_member2[i] == prev then
        # ʬȤǤʤΤǡƽФ̵ºƵƽФȤʤ
        am2[i] = self
      else
        am2[i] = array_member2[i].clone_for_composite( ct_name, cell_name, false )
      end

      # debug
      # p "clone_array_member: #{@name} #{am2[i]} #{array_member2[i]}"

      i += 1
    end

    # i = 0 ϡǼʬȤ
    # am2[0] = self

    @array_member  = am
    @array_member2 = am2

  end

  def self.gen_plugin_post_code
    tmp_file_name = "#{$gen}/tmp_plugin_post_code.cdl" 
    file = nil
    begin
      file = CFile.open( tmp_file_name, "w" )
    rescue
      Generator.error( "fail to create #{tmp_file_name}" )
    end
    @@newed_plugin_cell_count.each{ |plugin_name,count|
      begin
        eval_str = "#{plugin_name}.gen_post_code( file )"
        eval( eval_str )
      rescue Exception => evar
        Generator.error( "#{plugin_name}: fail to generate post code" )
      end
    }
    begin
      file.close
    rescue
      Generator.error( "fail to close #{tmp_file_name}" )
    end
    Import.new( "#{tmp_file_name}" )
  end

  #=== rhs 촹
  #rhs:: Expression | initializer
  # դ촹롥
  # Υ᥽åɤϡcomposite  cell °νͤ attribute ֤ͤΤ˻Ȥ
  # Υ᥽åɤ composite  cell °νͤǤϤʤˤʤä硢פˤʤ
  def change_rhs rhs
    @rhs = rhs
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Join: name: #{@name} global_name: #{@global_name} id: #{self}"
    if @subscript == nil then
    elsif @subscript >= 0 then
      (indent+1).times { print "  " }
      puts "subscript: #{@subscript}"
    else
      (indent+1).times { print "  " }
      puts "subscript: not specified"
    end
    (indent+1).times { print "  " }
    puts "rhs: "
    if @rhs.instance_of?( Array )then
      @rhs.each{ |i|
        if i.instance_of?( Array )then
          i.each{ |j|
            j.show_tree( indent + 3 )
          }
        elsif i.instance_of? Symbol then
          (indent+2).times { print "  " }
          print i
          print "\n"
        else
          i.show_tree( indent + 2 )
        end
      }
    else
      @rhs.show_tree( indent + 2 )
      (indent+1).times { print "  " }
      if @definition then
        puts "definition:"
        @definition.show_tree( indent + 2 )
      else
        puts "definition: not found"
      end
    end
    if @definition.instance_of?( Port ) then
      (indent+2).times { print "  " }
      if @cell then
        puts "cell: #{@cell_name}  port: #{@port_name}  cell_global_name: #{@cell.get_global_name}"
      else
        puts "cell: #{@cell_name}  port: #{@port_name}  cell_global_name: "
      end
    end
    if @through_list then
      i = 0
      @through_list.each { |t|
        (indent+2).times { print "  " }
        puts "through: plugin name :  '#{t[0]}' arg : '#{t[1]}'"
        @through_generated_list[i].show_tree( indent+3 )
        i += 1
      }
    end
    if @array_member2 then
      (indent+1).times { print "  " }
      puts "array member:"
      i = 0
      @array_member2.each { |j|
        if j then
          (indent+2).times { print "  " }
          puts "[#{i}]: #{j.get_name}  id: #{j}"
          j.get_rhs.show_tree(indent+3)
          (indent+3).times { print "  " }
          puts "cell global name: #{j.get_cell_global_name}"
          (indent+3).times { print "  " }
          puts "port global name: #{j.get_port_global_name}"
        else
          (indent+2).times { print "  " }
          puts "[#{i}]: [optional]  id: #{j}"
        end
        i += 1
      }
    end
  end

end


# CLASS: CompositeCelltype Ѥ Join
# REM:   CompositeCelltype  export 
class CompositeCelltypeJoin
# @export_name:: string     :  CompositeCelltype  export ̾ʸƤӸ°
# @internal_cell_name:: string : CompositeCelltype Υ̾
# @internal_cell_elem_name:: string : CompositeCelltype ΥθƤӸ°̾
# @cell : Cell : Cell::  internal cell  : CompositeCelltyep Υin_composite
# @port_decl:: Port | Decl
# @b_pseudo: bool : 

  def initialize( export_name, internal_cell_name,
		 internal_cell_elem_name, cell, port_decl )
    @export_name = export_name
    @internal_cell_name = internal_cell_name
    @internal_cell_elem_name = internal_cell_elem_name
    @cell = cell
    @port_decl = port_decl

  end

  #=== CompositeCelltypeJoin оݥ뤫
  #cell::  Cell оݤɤå륻
  #
  #     CompositeCelltypeJoin  cell ̾פ뤫å
  #     port_decl ꤵ줿ϡȤƤʤ
  def match?( cell, port_decl = nil )

    #debug
    #if port_decl
    #  printf( "@cell:      %-20s      %08x\n", @cell.get_name, @cell.object_id )
    #  printf( "@port_decl: %-20s      %08x\n", @port_decl.get_name, @port_decl.object_id )
    #  printf( "cell:       %-20s      %08x\n", cell.get_name, cell.object_id )
    #  printf( "port_decl:  %-20s      %08x\n", port_decl.get_name, port_decl.object_id )
    #end

    if port_decl then

      # debug
      # print "   cell_name: #{cell.get_name.class}=#{cell.get_name} cell_elem_name: #{port_decl.get_name.class}=#{port_decl.get_name}\n"
      # print "   @cell_name: #{@cell.get_name.class}=#{@cell.get_name} cell_elem_name: #{@port_decl.get_name.class}=#{@port_decl.get_name}\n"

    end


#    if @cell.equal?( cell ) && ( port_decl == nil || @port_decl.equal?( port_decl ) ) then
    # ʤ port_decl פʤФʤʤä˺줿
    # recursive_composite ̾ΰפѹ   060917
    if((@cell.get_name == cell.get_name) && (port_decl == nil || @port_decl.get_name == port_decl.get_name))then
      true
    else
      false
    end
  end

  def check_dup_init
    return if get_port_type != :CALL

    if @cell.get_join_list.get_item @internal_cell_elem_name then
      Generator.error( "'#{@internal_cell_name}.#{@internal_cell_elem_name}' has duplicate initializer" )
    end
  end

  def get_name
    @export_name
  end

  def get_cell_name
    @internal_cell_name
  end

  def get_cell
    @cell
  end

  def get_cell_elem_name
    @internal_cell_elem_name
  end

  # @port_decl  Port ξΤ߸ƤӽФƤ褤
  def get_port_type
    if @port_decl then
      @port_decl.get_port_type
    end
  end

  def get_port_decl
    @port_decl
  end

  # @port_decl  Port ξΤ߸ƤӽФƤ褤
  def is_require?
    if @port_decl then
      @port_decl.is_require?
    end
  end

  # @port_decl  Port ξΤ߸ƤӽФƤ褤
  def is_allocator_port?
    if @port_decl then
      @port_decl.is_allocator_port?
    end
  end

  # @port_decl  Port ξΤ߸ƤӽФƤ褤
  def is_optional?
    if @port_decl then
      @port_decl.is_optional?
    end
  end

  #=== դ Decl ʤнҡʼˤ֤
  # Υ᥽åɤ Cell  check_join ͥåΤ˸ƤӽФ
  def get_initializer
    if @port_decl.instance_of? Decl then
      @port_decl.get_initializer
    end
  end

  def get_size_is
    if @port_decl.instance_of? Decl then
      @port_decl.get_size_is
    end
  end

  #=== 󥵥
  #RETURN:: nil: not array, "[]": 礭ʤ, Integer: 礭ꤢ
  def get_array_size
    @port_decl.get_array_size
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "CompositeCelltypeJoin: export_name: #{@export_name} #{self}"
    (indent+1).times { print "  " }
    puts "internal_cell_name: #{@internal_cell_name}"
    (indent+1).times { print "  " }
    puts "internal_cell_elem_name: #{@internal_cell_elem_name}"
    if @port_decl 
      @port_decl.show_tree( indent + 1 )
    end
  end
end

class Factory
# @name:: string
# @file_name:: string
# @format:: string
# @arg_list:: Expression  elements Ʊ [ [:IDENTIFIER, String], ... ]
# @f_celltype:: bool : true: celltype factory, false: cell factory

  @@f_celltype = false

  def initialize( name, file_name, format, arg_list )
    @f_celltype = @@f_celltype

    case name
    when :write
      # write ؿ
      @name = name

      # write ؿե̾
        # ɾ̾ñʸǤ뤫顢ñʸ֤
      @file_name = file_name.eval_const(nil).val  # file_name : Expression
      if ! @file_name.instance_of?( String ) then
        # ʸǤϤʤä
        Generator.error( "#{@name}: 1st parameter is not string(file name)" )
        @file_name = nil
      end

      # write ؿեޥåʸ
      @format    = format.eval_const(nil).val     # format : Expression
        # ɾ̾ñʸǤ뤫顢ñʸ֤
      if ! @format.instance_of?( String ) then
        # ʸǤϤʤä
        Generator.error( "#{@name}: 2nd parameter is not string(fromat)" )
        @format = nil
      end

      # 軰ʹߤꥹȤȤ mikan Υå
      @arg_list = arg_list

    else
      Generator.error( "#{name}: unknown factory function" )
    end
    Celltype.new_factory( self )
  end

  def check_arg( celltype )
    if ! @arg_list then
      return
    end

    if @f_celltype then
      Generator.error( "celltype factory can't have parameter(s)" )
      return
    end

    @arg_list.each{ |elements|

      case elements[0]
      when :IDENTIFIER
        obj = celltype.find( elements[1] )
        if obj == nil then
          Generator.error( "'#{elements[1]}': not found" )
        elsif ! obj.instance_of?( Decl ) || obj.get_kind != :ATTRIBUTE then
          Generator.error( "'#{elements[1]}': not attribute" )
        end
      when :STRING_LITERAL
      else
        Generator.error( "internal error Factory.check_arg()" )
      end

    }
  end

  def self.set_f_celltype( f_celltype )
    @@f_celltype = f_celltype
  end

  def get_f_celltype
    @f_celltype
  end

  def get_name
    @name
  end

  def get_file_name
    @file_name
  end

  def get_format
    @format
  end

  def get_arg_list
    @arg_list
  end

  def show_tree( indent )
    indent.times { print "  " }
    puts "Factory: name: #{@name}"
    if @arg_list then
      (indent+1).times { print "  " }
      puts "argument(s):"
      @arg_list.each { |l|
        (indent+2).times { print "  " }
        print "\"#{l}\"\n"
      }
    end
  end
end

class Region
# @name:: string
# @family_line:: [ @region_root, ...,@region_me ]  ȷ
# @in_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil λ in ػ
# @out_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil λ out ػ
# @to_through_list:: [ [ dst_region, plugin_name, plugin_arg ], ... ]
# @b_generate:: bool : true if оݥ꡼
# @region_1st_appear:: Region : ǽ˽иȤ region : ǽνиǤ nil
# @cell_port_throug_plugin_list:: { "#{cell_name}.#{port_name}" => through_generated_list  }
#     region  cell_name.port_name ؤ through ץ饰줿֥

  # Generator  nest  (RootRegionΤȤ=0, through,in/out/to_throughƤȤ > 0)
  @@region_nest_count = -1

  # region å (¾βսǤ stack  Generator  nest  push 뤿ѤƤ㤷Ƥ)
  @@region_stack_sp = -1
  @@region_stack = []

  @@in_through_list  = []
  @@out_through_list = []
  @@to_through_list  = []

  # Region 򤷤ʤin_through,out_through,to_through줿cellˤregionŬѤʤ
  def self.push
    @@region_nest_count += 1
  end

  def self.pop
    @@region_nest_count -= 1
  end

  def initialize( name )

    @name = name

    @@region_stack_sp += 1

    # mikan name  Namespace 
    object = Namespace.find( [ name ] )
    if object then
      if object.instance_of?( Region ) then
        # ƽи
        @@region_stack[@@region_stack_sp] = object
        @region_1st_appear = object

        # ƽи specifier ꤵƤ뤫
        if( @@in_through_list.length != 0 || @@out_through_list.length != 0 || @@to_through_list.length != 0 )then
          Generator.error( "#{name}: region specifier must place at first appearence" )
        end

      else
        # 顼ѥߡ
        @region_1st_appear = nil
        @family_line = []

        # ۤʤƱ̾Υ֥ȤѤ
        Generator.error( "#{name} duplication, previous one : #{object.class}" )
        @@region_stack[@@region_stack_sp] = self    # 顼 region
      end
    else
      # и
      @@region_stack[@@region_stack_sp] = self

      # ʣˤɲ
      @family_line = @@region_stack[0,@@region_stack_sp+1].dup

      Namespace.new_region( self )

      @in_through_list  = @@in_through_list
      @out_through_list = @@out_through_list
      @to_through_list  = @@to_through_list

    end    

    @@in_through_list  = []
    @@out_through_list = []
    @@to_through_list  = []

    @cell_port_throug_plugin_list = {}

# p @name
# p @in_through_list
# p @out_through_list
# p @to_through_list

    # оݥ꡼
    if $region_list.length > 0 then
      # ץ
      @b_generate = $region_list[ get_path_string ]
    else
      @b_generate = true
    end
  end

  def self.end_of_parse
    @@region_stack_sp -= 1
    if @@region_stack_sp == -2 then
      raise "RegionStackUnderflow"  # never come here
    end
  end

  def self.new_in_through( plugin_name = nil, plugin_arg = nil )
    @@in_through_list << [ plugin_name, plugin_arg ]
  end

  def self.new_out_through( plugin_name = nil, plugin_arg = nil )
    @@out_through_list << [ plugin_name, plugin_arg ]
  end

  def self.new_to_through( dst_region, plugin_name, plugin_arg )
    # p "New to_through #{dst_region}"
    @@to_through_list  << [ dst_region, plugin_name, plugin_arg ]
  end

  def get_name
    @name
  end

  def get_family_line
    if( @region_1st_appear )
      @region_1st_appear.get_family_line
    else
      @family_line
    end
  end

  def get_in_through_list
    if( @region_1st_appear )
      @region_1st_appear.get_in_through_list
    else
      @in_through_list
    end
  end

  def get_out_through_list
    if( @region_1st_appear )
      @region_1st_appear.get_out_through_list
    else
      @out_through_list
    end
  end

  def get_to_through_list
    if( @region_1st_appear )
      @region_1st_appear.get_to_through_list
    else
      @to_through_list
    end
  end

  def get_path_string
    if( @region_1st_appear )
      @region_1st_appear.get_path_string
    else
      pstring = ""
      delim = ""
      @family_line.each{ |p|
        pstring = "#{pstring}#{delim}#{p.get_name}"
        delim = "."
      }
      pstring
    end
  end

  def self.get_current
    @@region_stack[@@region_stack_sp]
  end

  #=== оݡ
  # ꡼ʤ true Ǥʤ false ֤
  def is_generate?
    @b_generate
  end

  #=== through ץ饰ǡ region  cell_name.port_name ؤΥץ饰󥪥֥ȤϿ
  # mikan namespace б (cell_name)
  def add_cell_port_through_plugin( cell_name, port_name, through_plugin_object )
    @cell_port_throug_plugin_list[ "#{cell_name}.#{port_name}" ] = through_plugin_object
  end

  def find_cell_port_through_plugin( cell_name, port_name )
    return @cell_port_throug_plugin_list[ "#{cell_name}.#{port_name}" ]
  end

  def show_tree( indent )
    indent.times { print( "  " ) }
    puts "Region: name: #{@name}"
    (indent+1).times { print( "  " ) }
    puts "path: #{get_path_string}"
  end
end

class Import_C

  # إå̾ʸΥꥹ
  @@header_list = {}
  @@define_list = {}

  #=== import_C ʥإåե
  #header:: Token : import_C ʸƥȡ
  #define:: Token : import_C ʸƥȡ
  def initialize( header, define = nil )

    # إåե̾ʸ󤫤 "" 
    header = header.to_s.gsub( /^"(.*)"$/, '\1' )

    if define then
      #  "" 
      def_opt = define.to_s.gsub( /^"(.*)"$/, '\1' )

      # ","  -D ֤
      def_opt = def_opt.gsub( /,/, " -D " )

      # Ƭ -D  # mikan Ŭڤ define Ϥä硢CPP ˥顼
      def_opt = def_opt.gsub( /^/, "-D " )

    end

    # ޥɥ饤ꤵ줿 DEFINE 
    $define.each{ |define|
      def_opt = "#{$def_op} -D #{define}"
    }

    include_opt = ""
    found = false
    header_path = ""
    $import_path.each{ |path|
      include_opt = "#{include_opt} -I #{path}"
      if found == false then
        begin
          # ե stat äƤߤ(ʤ㳰ȯ)
          File.stat( "#{path}/#{header}" )

          # cdl 򸫤Ĥäեѥ˺
          header_path = "#{path}/#{header}"
          found = true
        rescue
          found = false
        end
      end
    }

    if found == false then
      Generator.error( "#{header} not found in search path" )
      return
    end

    # ɹߺѤߡ
    if( @@header_list[ header ] )
      #  define Ȱۤʤ
      if @@define_list[ header ].to_s != define.to_s then
        Generator.error( "import_C: arg2: mismatch with previous one" )
      end
      # ˤɤ߹ޤʤ
      return
    end

    # إåΥꥹȤϿ
    @@header_list[ header ] = header_path
    @@define_list[ header ] = define

    begin
      tmp_C = "#{$gen}/tmp_C_src.c"
      file = File.open( tmp_C, "w" )
    rescue
      Generator.error( "#{tmp_C}: temporary C source: open error" )
    end

    begin
      file.print( "#include \"#{header}\"\n" )
    rescue
      Generator.error( "#{tmp_C}: temporary C source: writing error" )
    ensure
      file.close
    end

    # CPP  tmp ե̾
    tmp_header = header.gsub( /\//, "_" )
    tmp_header = "#{$gen}/tmp_#{tmp_header}"

    # CPP ޥɥ饤
    cmd = "#{$cpp} #{def_opt} #{include_opt} #{tmp_C}"

    begin
      if( $verbose )then
        puts "CPP: #{cmd}"
      end

      # ץץåޥɤ pipe ȤƳ
          # cmd  cygwin/Linux Ǥ bash(sh) ͳǼ¹Ԥ
          # Exerb ǤǤ cmd.exe ͳǼ¹Ԥ
          # κϰ (), $, % ʤɥ̤ʸɾ˸Τ
      cpp = IO.popen( cmd, "r" )
      begin
        tmp_file = nil
        tmp_file = File.open( tmp_header, "w" )
        cpp.each { |line|
          line = line.gsub( /^#(.*)$/, '/* \1 */' )
          tmp_file.puts( line )
        }
      rescue
        Generator.error( "#{header}: error occured while CPP" )
      ensure
        tmp_file.close if tmp_file    # mikan File.open ˼Ԥ tmp_file == nil ݾڤƤ ?
        cpp.close
      end
    rescue
      Generator.error( "#{header}: popen for CPP failed" )
    end

    # C Υѡ󥹥󥹤
    c_parser = C_parser.new

    # tmp_header ѡ
    c_parser.parse( [tmp_header] )

    # ѡå᤹
    c_parser.finalize

  end

  def self.get_header_list
    @@header_list
  end
end

class Import
# @b_reuse::      bool ѡ륿פ template 
# @b_reuse_real:: bool ºݤ˺
# @cdl::      string   import  CDL
# @cdl_path:: string   CDL Υѥ

  # إå̾ʸΥꥹ  źexpand ѥ͡Import
  @@import_list = {}

  #=== import Ԥ
  #cdl::      string   cdl ؤΥѥ"" ǰϤޤƤ뤳Ȥ
  #b_reuse::  bool     true: template ʤ
  def initialize( cdl, b_reuse = false )

    # إåե̾ʸ󤫤 "", <> n
    @cdl = cdl.to_s.gsub( /\A["<](.*)[">]$/, '\1' )

    # ѥõ
    found = false
    @cdl_path = ""

    @b_reuse = b_reuse
    @b_reuse_real = @b_reuse || Generator.is_reuse?

    if Generator.get_plugin then
      # plugin  import Ƥ gen 򥵡ѥƬ˲ä
      search_path = [ $gen ] + $import_path
    else
      search_path = $import_path
    end

    search_path.each{ |path|
       begin
         # ե stat äƤߤ(ʤ㳰ȯ)
         File.stat( "#{path}/#{@cdl}" )

         # cdl 򸫤Ĥäեѥ˺
         @cdl_path = "#{path}/#{@cdl}"
         found = true
         break
       rescue
         found = false
       end
    }

    if found == false then
      Generator.error( "#{@cdl} not found in search path" )
      return
    end

    # ɹߺѤߤʤ顢ɹޤʤ
    prev = @@import_list[ File.expand_path( @cdl_path ) ]
    if( prev )
      if prev.is_reuse_real? != @b_reuse_real then
        Generator.warning( "#{@cdl}: reuse designation mismatch with previous import" )
      end
      return
    end

    # import ꥹȤϿ
    @@import_list[ File.expand_path( @cdl_path ) ] = self

    # plugin  import Ƥ
    plugin = Generator.get_plugin

    # ѡ󥹥󥹤(̥ѡɤ߹)
    parser = Generator.new

    # plugin  import Ƥ plugin 
    parser.set_plugin plugin

    # reuse ե饰
    parser.set_reuse @b_reuse_real

    # cdl ѡ
    parser.parse( [@cdl_path] )

    # ѡå᤹
    parser.finalize
  end

  def self.get_list
    @@import_list
  end

  def get_cdl_path
    @cdl_path
  end

  def is_reuse_real?
    @b_reuse_real
  end

end
