/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * ƤӸؿ #_TCPF_#
 * require port : signature: sSVC context: task
 *   ER             systemCall( );
 * call port : cCall  signature: sSimple context: task
 *   void           cCall_shutdown( );
 *   ER             cCall_func1( int32_t inval );
 *   ER             cCall_func2( char_t* str );
 *   ER             cCall_func3( const char_t* msg, int32_t len );
 * call port : cTDR  signature: sTDR context: task
 *   ER             cTDR_open( const int8_t* arg, int16_t size, TMO tmo );
 *   ER             cTDR_close( );
 *   ER             cTDR_reset( );
 *   ER             cTDR_sop( int_t no );
 *   ER             cTDR_is_sop( int_t no );
 *   ER             cTDR_eop( );
 *   ER             cTDR_is_eop( );
 *   ER             cTDR_set_tmo( TMO tmo );
 *   ER             cTDR_put_int8_t( int8_t in );
 *   ER             cTDR_put_int16( int16_t in );
 *   ER             cTDR_put_int32( int32_t in );
 *   ER             cTDR_put_int64( int64_t in );
 *   ER             cTDR_put_int128( int128_t in );
 *   ER             cTDR_get_int8_t( int8_t* out );
 *   ER             cTDR_get_int16( int16_t* out );
 *   ER             cTDR_get_int32( int32_t* out );
 *   ER             cTDR_get_int64( int64_t* out );
 *   ER             cTDR_get_int128( int128_t* out );
 *   ER             cTDR_put_char( char_t in );
 *   ER             cTDR_put_short( short in );
 *   ER             cTDR_put_int( int_t in );
 *   ER             cTDR_put_long( long_t in );
 *   ER             cTDR_get_char( char_t* out );
 *   ER             cTDR_get_short( short* out );
 *   ER             cTDR_get_int( int_t* out );
 *   ER             cTDR_get_long( long_t* out );
 *   ER             cTDR_put_intptr( const void* ptr );
 *   ER             cTDR_get_intptr( void** ptr );
 *
 * #[</PREAMBLE>]# */

#include "tSimpleClient_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* ｪλ */
#define	E_ID	(-18)	/* IDֹ */
#endif

int main( int argc, char **argv )
{
	char   buf[256];

	syslog( LOG_INFO, "SimpleClient: opening TDR" );
	cTDR_open("", 0, TMO_FEVR );

	syslog( LOG_INFO, "SimpleClient: cCall_func1" );
	cCall_func1( 10 );

	syslog( LOG_INFO, "SimpleClient: cCall_func2" );
	cCall_func2( "hello" );

#define FUNC3_MSG  "message for func3"
	syslog( LOG_INFO, "SimpleClient: cCall_func3" );
	cCall_func3( FUNC3_MSG, sizeof FUNC3_MSG );

	syslog( LOG_INFO, "SimpleClient: shutdown server" );
	cCall_shutdown();

	syslog( LOG_INFO, "SimpleClient: closing TDR" );
	cTDR_close();
}
/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
